#ifndef _CANIMATE_BUTTON_
#define _CANIMATE_BUTTON_

#include <QtGui>

class CAnimateButton : public QLabel {
  Q_OBJECT
  private:
    QMovie *mov;

  protected:
     virtual void mousePressEvent(QMouseEvent*);

  public:
    CAnimateButton( QString = "", QWidget *wgt = 0 );

  public slots:
    inline void setFileNameAnimation(QString filename) {
      mov->setFileName(filename);
    }
    inline void start() {
      mov->start();
    }
    inline void stop() {
      mov->stop();
      mov->jumpToFrame(0);
    }
    inline QMovie::MovieState state() {
      return mov->state();
    }
    inline QSize scaledSize() {
      return mov->scaledSize();
    }
    inline void setScaledSize(QSize size) {
      mov->setScaledSize(size);
    }

  signals:
    void clicked();

};

#endif
