#ifndef _CICON_VIEWER_CONTROL_
#define _CICON_VIEWER_CONTROL_

#include <QtGui>
#include "PixmapsCache.h"
#include "ToolBar.h"
#include "Button.h"
#include "About.h"
#include "Palette.h"

class CIconViewerControl : public CToolBar {
  Q_OBJECT
  private:
    PixmapsCache *pxCache;
    QSettings settings;
    QString view, panel;
    CButton         *List,
                            *Icons,
                            *Table,
                            *FlatButton,
                            *TextButton,
                            *InvertColor,
                            *OnePanel,
                            *TwoPanel,
                            *TreePanel,
                            *Thumbnails,
                            *LeftToRight,
                            *RightToLeft,
                            *OneOne,
                            *About;

    bool Flat,
             Text,
             Invert,
             Thumbs;

    void readSettings();
    void writeSettings();

  public:
    bool SaveSettings;

  public:
    CIconViewerControl(PixmapsCache*, QWidget *wgt = 0);
    ~CIconViewerControl();

    inline QString getView(){
      return view;
    }
    inline bool getFlat(){
      return Flat;
    }
    inline bool getText(){
      return Text;
    }
    inline bool getInvert(){
      return Invert;
    }
    inline QString getPanel() {
      return panel;
    }

  signals:
    void changeView ( QString, bool );
    void changeFlat (bool);
    void changeThumbs(bool);
    void changePanel(QString);
    void openContentInOther(QString);

  public slots:
    void clickedView(CButton*);
    void setBackColor(QColor);
    void setFontColor(QColor);
    void clickFlat();
    void setText();
    void refreshTheme();

    inline void showAboutWindow() { new CAbout(pxCache, this->palette()); }
    inline void setEnabledButtonOpen(bool en) {
      LeftToRight->setEnabled(en);
      RightToLeft->setEnabled(en);
      OneOne->setEnabled(en);
    }
    inline void setEnabledButtonView(bool en) {
      List->setEnabled(en);
      Icons->setEnabled(en);
      Table->setEnabled(en);
    }

};

#endif
