#ifndef _CICON_VIEWER_MOVING_
#define _CICON_VIEWER_MOVING_

#include <QtGui>
#include "ToolBar.h"
#include "Button.h"
#include "PixmapsCache.h"

class CIconViewerMoving : public CToolBar {
Q_OBJECT
 private:
    QPalette palette;
    PixmapsCache *pxCache;
    CButton            *back_Button,
                               *next_Button,
                               *up_Button,
                               *home_Button,
                               *refresh_Button;

  public:
    CIconViewerMoving( QWidget *wgt = 0 );

    void setPixmapsCache ( PixmapsCache *);
    void refreshTheme();

    inline void setUpEnabled ( bool b ) { up_Button->setEnabled (b); }
    inline void setBackEnabled ( bool b ) { back_Button->setEnabled (b); }
    inline void setNextEnabled ( bool b ) { next_Button->setEnabled ( b ); }
    inline void setHomeEnabled ( bool b ) { home_Button->setEnabled ( b ); }
    inline void setRefreshEnabled ( bool b ) { refresh_Button->setEnabled ( b ); }
    inline QList<CButton*> getMovingButtons() { return ListButton; }
};

#endif
