#ifndef _CICON_VIEWER_PANEL_
#define _CICON_VIEWER_PANEL_

#include <QtGui>
#include "IconViewerPanelBase.h"

class CIconViewerPanel : public CIconViewerPanelBase {
  Q_OBJECT
  private:
    bool queryQuestions;

  public:
    CThreadMonitor *Monitor;
    bool SaveSettings;
    QRect Rect;

  private:
    void readSettings();
    void writeSettings();
    void setBitMonitor();

  public:
    CIconViewerPanel( PixmapsCache *, ReserveCache*, ReserveCache*,  QWidget *wgt = 0);
    ~CIconViewerPanel();

  public slots:
    void setFontSize();
    void setBackColor(QColor);
    void setFontColor(QColor);

    inline void changeShowWarningRemove(){
      if (*showWarningRemove) {
        *showWarningRemove = false;
        bitState->setBit(1, true);
        bitState->setBit(0, false);
      }
      else {
        *showWarningRemove = true;
        bitState->setBit(0, true);
        bitState->setBit(1, false);
      }
    }

    void showCopyParametres();
    void showProgressW();
    void hideProgressW();
    void switchVisibleProgressW();
    void resizeProgressW(QRect);
    void resizeProgressW();

};

#endif
