#ifndef _CSELECT_APPLICATION_
#define _CSELECT_APPLICATION_

#include <QtGui>
#include "PixmapsCache.h"

class CComboBox : public QComboBox {
  Q_OBJECT
  protected:
    virtual void keyPressEvent(QKeyEvent*);
  public:
    CComboBox(QWidget *wgt = 0);
  signals:
    void returnPressed();
};

class CSelectApplicationWindow  : public QDialog {
  Q_OBJECT
  private:
    PixmapsCache *pxCache;
    QColor Color;
    int LastItem;
    QFileInfo FileInfo;
    QString MimeType, FileName;
    QList<QListWidgetItem*> ListItem;

    QGridLayout *GridLayout;
    QLabel *Label1, *Label2, *Notes;
    CComboBox *ComboBox;
    QPushButton *OkButton, *CancelButton, *SelectButton;
    QListWidget *ListWidget;
    QCheckBox *CheckBox;
    CExcludeEvents *ExcludeEvents;

  protected:
    virtual void closeEvent(QCloseEvent*);


  public:
    CSelectApplicationWindow(PixmapsCache*, QFileInfo, QWidget *wgt = 0);
    void setPalette(QPalette, QColor);
    QString exec();

  public slots:
    void clickedItem(QListWidgetItem*);
    void signalFromButton();
    void signalFromCombo();
    void indexChanged(int);
    void signalFromSelect();
    void signalFromCheck();
    void signalDoubleClicked(QListWidgetItem*);

};

#endif
