#ifndef _CSTATUS_BAR_
#define _CSTATUS_BAR_

#include <QtGui>
#include "PixmapsCache.h"

class CTryEvent : public QObject {
  Q_OBJECT
  protected:
    virtual bool eventFilter(QObject*, QEvent*);
  public:
    CTryEvent (QObject* obj = 0);
  signals:
    void closeWnd();
};

class CStatusBar : public QWidget {
  Q_OBJECT
  private:
    QFileInfoList listdrives;
    PixmapsCache             * pxCache;
    QLabel                           * labelIcon,
                                            * labelName,                 * labelNameH,
                                            * labelType,                   * labelTypeH,
                                            * labelMimeType,         * labelMimeTypeH,
                                            * labelModified,             * labelModifiedH,
                                            * labelSize,                    * labelSizeH,
                                            * labelDescription,        * labelDescriptionH,
                                            * labelTarget,                 * labelTargetH,
                                                                                    * labelAbcFilterHRight,
                                                                                    * labelMimeFilterHRight,
                                                                                    * labelTemplateFilterHRight,
                                                                                    * labelAbcFilterHLeft,
                                                                                    * labelMimeFilterHLeft,
                                                                                    * labelTemplateFilterHLeft;


     int FilterSize, NameSize, MimeSize;

     QGridLayout                * layoutDescription,
                                            * layoutFilterRight,
                                            * layoutFilterLeft;

     QHBoxLayout               * mainLayout,
                                             * shellLayout;

     QMenu                           *templateMenuRight,
                                             *templateMenuLeft,
                                             *mimeMenuRight,
                                             *mimeMenuLeft;

     QList<QString> MimeTypeString, MimeTypeComment,
                                 MimeTypeStringUser, MimeTypeCommentUser,
                                 TemplateString, TemplateComment,
                                 TemplateStringUser, TemplateCommentUser;

    QAction *ExcludeDirsMimeLeft, *ExcludeDirsTemplateLeft,
                    *ExcludeDirsMimeRight, *ExcludeDirsTemplateRight;

     bool twofilter, excludeDirsMimeLeft, excludeDirsTemplateLeft,
                             excludeDirsMimeRight, excludeDirsTemplateRight;

     CExcludeEvents *ExcludeEvents;

     void readSettings();
     void writeSettings();

     //-----------                                               Filters window           -----------------------------------------------------------------------

  QDialog *dialogWnd;
  QVBoxLayout *mainFiltersLayout;
  QGroupBox * filterViewBox;
  QVBoxLayout *filterViewLayout;
  QTreeWidget *viewFilter;
  QTreeWidgetItem *item;
  QHBoxLayout *buttonsLayout;
  QPushButton *newButton;
  QPushButton *removeButton;
  QPushButton *editButton;
  QPushButton *closeButton;
  QGroupBox * addedBox;
  QGridLayout *addedLayout;
  QLineEdit *nameEdit;
  QLineEdit *filterEdit;
  QLabel *nameLabel;
  QLabel *filterLabel;
  QHBoxLayout *addedButtonsLayout;
  QPushButton *okButton;
  QPushButton *cancelButton;
  bool MimeFilter;
  int fH;
  QChar op;
  QString nname, nfilter;

//--------------                                       End of Filters Window                                            ---------------------------------------------------

  public:
    QLineEdit                     *abcFilterRight, *abcFilterLeft;
    QPushButton                *templateFilterRight, *templateFilterLeft,
                                           *mimeFilterRight, *mimeFilterLeft;
    QFont *font;
    QColor Color;

  public:
    CStatusBar(PixmapsCache *, QWidget * wgt = 0);
    ~CStatusBar();

    void setOneFilter();
    void setTwoFilter();
    void setMaxSizes();
    inline bool getExcludeDirsMimeLeft()                    { return excludeDirsMimeLeft; }
    inline bool getExcludeDirsTemplateLeft()             { return excludeDirsTemplateLeft; }
    inline bool getExcludeDirsMimeRight()                 { return excludeDirsMimeRight; }
    inline bool getExcludeDirsTemplateRight()          { return excludeDirsTemplateRight; }

  protected:
    virtual void resizeEvent(QResizeEvent*);

  private slots:
    void clickMimeMenuRight();
    void clickMimeMenuLeft();
    void clickTemplateMenuRight();
    void clickTemplateMenuLeft();
    void clickExcludeDirs();

  public slots:
    void setFontColor(QColor);
    void setBackColor(QColor);
    void setFontSize();
    void refreshWrite( QDir, bool );
    void refreshWrite(QFileInfo, bool);
    void refreshWrite(int);
    void refreshWrite();
    void setTextAbcRight(QString);
    void delSymbolAbcRight();
    void setTextAbcLeft(QString);
    void delSymbolAbcLeft();
    void hideRightFilter(bool);
    void hideLeftFilter(bool);
    void createFiltersMimeMenu();
    void createFiltersTemplateMenu();
    void showErrorFilter();

//----------------                                      slots window filter             ---------------------------------------------------------------------------
    void addRemoveFilters();
    void closeWindowFilter();
    void createNewFilter();
    void hideFiltersPanel();
    void activatedItem(QTreeWidgetItem*);
    void removeFilter();
    void setFileFilter();
    void filterEditChanged();
    void editFilter();

//----------------                                    end  slots window filter            ---------------------------------------------------------------------------

  signals:
    void changeMimeFilterRight(QString);
    void changeMimeFilterLeft(QString);
    void changeTemplateFilterRight(QString);
    void changeTemplateFilterLeft(QString);
    void changeExcludeDirsMimeLeft(bool);
    void changeExcludeDirsTemplateLeft(bool);
    void changeExcludeDirsMimeRight(bool);
    void changeExcludeDirsTemplateRight(bool);

};

#endif
