#ifndef _CTEXT_VIEWER_
#define _CTEXT_VIEWER_

#include <QtGui>
#include "TextViewerTool.h"
#include "MessageBox.h"

class CTextViewerTool;

class CTextViewer : public QTextEdit {
  Q_OBJECT
  private:
    CTextViewerTool *TextViewerTool;
    CMessageBox *Message;
    QPalette epal;

  public:
    QString FileName;
    QString dir;
    int Scale;
    QFont *Font;

  public:
    CTextViewer(QWidget *wgt = 0);

    void setTextViewerTool (CTextViewerTool *);
    void setFontSize();
    void loadText(QString);
    void errorMessage(QString);
    void setCastomPalette(QPalette, QColor);

  protected:
    virtual void contextMenuEvent(QContextMenuEvent*);

  public slots:
    void ifTextChanged();
    void dontEditClicked();
    void undoButtonClicked();
    void redoButtonClicked();
    void reloadText();
    void scaleTextPlus();
    void scaleTextMinus();
    void saveText();
    void saveTextAs();

  signals:
    void changeNewPath(QString);

};

#endif
