#ifndef _CTOOL_BAR_
#define _CTOOL_BAR_

#include <QtGui>
#include "Button.h"
#include "PointSeparator.h"
#include "AnimateButton.h"
#include "Palette.h"

class CToolBar : public QFrame {
  Q_OBJECT

  private:
    bool Flat, Text;
    QSize IconSize;
  public:
    QHBoxLayout  Layout;
  private:
    QList<CButton*> ListButton;
    QFont *Font;
    QList<QString> ListLabel;
    QWidget *Separator;
    QList<QWidget*> ListSeparator;
    QList<CPointSeparator*> ListPointSeparator;
    QList<CAnimateButton*> ListAnimateButton;

  public:
    CToolBar ( QWidget *wgt = 0 );
    CButton* addAction (const QIcon &icon, const QString &toolTip);
    CButton* addAction (const QString &text, const QString &toolTip);
    CButton* addAction  (const QIcon &icon, const QString &text,  const QString &toolTip);

    CAnimateButton * addAction(QString);

    void setFlat (bool);
    inline bool flat(){
      return Flat;
    }
    void setIconSize (QSize);
    inline QSize iconSize(){
      return IconSize;
    }
    void setShowText(bool show);
    inline bool showText(){
      return Text;
    }
    inline void setFont(QFont *font){
      Font = font;
    }
    inline QFont* font() {
      return Font;
    }

    void clear();
    void addSeparator();
    void addPoint();

  public slots:
    void setBackColor (QColor);
    void setFontColor (QColor);
    void setFontSize();
    void changeFlat();
    void clickButton();
    void clickAnimateButton();

  signals:
    void clickedButton(CButton*);
    void clickedAnimateButton(CAnimateButton*);

friend class CIconViewerMoving;
friend class CIconViewerNavigator;

};

#endif
