#ifndef _CTREE_VIEWER_PANEL_
#define _CTREE_VIEWER_PANEL_

#include <QtGui>
#include "TreeViewer.h"
#include "TreeViewerSettings.h"

class CTreeViewerPanel : public QFrame {
  Q_OBJECT

  private:
    CTreeViewer *Viewer;
    CTreeViewerSettings *ViewerControl;
    QVBoxLayout * Layout;

    PixmapsCache *pxCache;


  public:
    CTreeViewerPanel ( PixmapsCache *, QWidget * wgtg = 0  );

  signals:
    void clickedElement(QTreeWidgetItem*, int);
    void execOperation(QString, QString);

  public slots:
    void setShowHidden (bool);
    void setBackgroundColor (QColor);
    void setBackgroundTexture (QPixmap);
    void setFontColor (QColor);
    void setFontSize (int);
    void setIconSize(QSize);
    void setFlat(bool);
    void refreshTheme();

    friend class WidgetManager;

};

 #endif
