#ifndef _CWEB_HISTORY_
#define _CWEB_HISTORY_

#include <QtGui>
#include "WebViewer.h"

class CWebViewer;

class CWebHistory : public QObject {
  Q_OBJECT
  private:
    int CurrentItem;
    int MaximumSize;
    QList<QIcon>  IconList;
    QStringList     TitleList;
    QStringList     LinkList;

  public:
    CWebHistory();

    void addItem (CWebViewer*);

    QIcon icon( int n = -1)                                    { if (n==-1) return   IconList[CurrentItem]; else return IconList[n];  }
    QString title( int n = -1)                                  { if (n==-1) return   TitleList[CurrentItem]; else return TitleList[n];  }
    QString link( int n = -1)                                  { if (n==-1) return   LinkList[CurrentItem]; else return LinkList[n];  }

    void setCurrentItem (int item)       { CurrentItem = item;                                                                             }
    int currentItem()                              { return CurrentItem;                                                                             }
    void setMaximumSize (int size = 20);
    int maximumSize()                         { return MaximumSize;                                                                        }

    bool canGoBack()                          { if (CurrentItem > 0) return true; else return false;                       }
    bool canGoForward()                    { if (CurrentItem < count() - 1) return true; else return false;        }

    void back()                                       { if (CurrentItem > 0) CurrentItem--;                                                    }
    void forward()                                  { if (CurrentItem < count() - 1) CurrentItem++;                                   }
    int count()                                         { return LinkList.count();                                                                      }

    void loadHistory();
    void loadHistory(CWebHistory*);
    void saveHistory();
    void clear();

};

#endif

