#ifndef _CWEB_VIEWER_
#define _CWEB_VIEWER_

#include <QtGui>
#include <QWebView>
#include <QWebHistory>
#include <QWebPage>
#include <QWebFrame>
#include <QWebHitTestResult>
#include <QWebElement>
#include "WebHistory.h"
#include "WebViewerTool.h"

class CWebHistory;

class CWebViewer : public QWebView {
  Q_OBJECT
  private:
    CWebViewerTool *WebViewerTool;
    CWebHistory *WebHistory;
    QAction *ActionClear;
    bool AddHistory;
    QWebElement CharsetElement;
    QString Charset, OriginalCharset, StringFromCharset;
    QLineEdit * WebViewerStatus;
    QPalette epal;
    QString PageEncoding;
    QMenu *GroupCodecsMenu;
    int MaxWidth;
    QAction *EncodingAct;
    QList<QMenu*> ListMenu;

  public:
    QUrl lastAdress;
    qreal Scale;

  public:
    CWebViewer ( QWidget *wgt = 0 );

    void setToolAndHistory(CWebViewerTool*, CWebHistory*, QLineEdit*);
    void addHistoryItem();
    void setCastomPalette(QPalette, QColor);

  protected:
    virtual void contextMenuEvent(QContextMenuEvent*);

  public slots:
    void loadingComplete(bool);
    void goAdress(QUrl);
    void goAdress();
    void back();
    void forward();
    void scalePlus();
    void scaleMinus();
    void clearHistory();
    void setStatusBarText(QString, QString, QString);
    void changeEncoding();

};

#endif
