#ifndef _CWEB_VIEWER_TOOL_
#define _CWEB_VIEWER_TOOL_

#include <QtGui>
#include <QWebView>
#include "ToolBar.h"
#include "PixmapsCache.h"

class CWebViewerTool : public CToolBar {
  Q_OBJECT
  private:
    QProgressBar *LoadProgress;
    QLabel *LoadProgressState;
    PixmapsCache *pxCache;
  public:
    CButton *History, *PrevButton, *ForwardButton, *RefreshButton,
                    *ScaleButtonPlus, *ScaleButtonMinus, *ClearHistoryButton,
                    *PageEncodingButton;
    QMenu *WebHistoryMenu;
    QLabel *ScalePage;

  public:
    CWebViewerTool ( PixmapsCache *, QWidget *wgt = 0);
    void setIconSize(QSize);
    void refreshTheme();

  public slots:
    void setProgress(int);
    void startLoading();
    void setFontSize();

friend class CWebViewer;
friend class CWebHistory;

};

#endif
