#ifndef _CWIDGET_MANAGER_
#define _CWIDGET_MANAGER_

#include "TreeViewer.h"
#include "TreeViewerSettings.h"
#include "TreeViewerPanel.h"
#include "IconViewer.h"
#include "IconViewerPanel.h"
#include "PixmapsCache.h"
#include "IconViewerControl.h"
#include "IconViewerSettings.h"
#include "MainWidget.h"
#include "Splitter.h"
#include "ToolBar.h"
#include "StatusBar.h"

class WidgetManager : public QObject {
  Q_OBJECT
  private:
    QString panel;
    MainWidget *MainWgt;
    QVBoxLayout *MainLay, *lay;
    CSplitter *split;
    ReserveCache *rcache1, *rcache2, *rcache3, *rcache4;
    PixmapsCache *cache;
    QFrame *frame;
    CIconViewerControl *control;
    CIconViewerSettings *settings;
    CIconViewerPanel *firstIconWidget;
    CIconViewerPanelBase *secondIconWidget;
    CTreeViewerPanel *treeWidget;
    CStatusBar *statusBar;

    bool twopanel;

  public:
    bool SaveSettings;

  public:
    WidgetManager (char **argv);
    ~WidgetManager();

    inline void show() {
      MainWgt->show();
    }

  public slots:
    void changePanel(QString);
    void hideStatusBarF(bool);
    void hideStatusBarS(bool);
    void setNotSaveSettings();
    void openContentInOther(QString);
    void setNewSplitterSize(QRect);

};

#endif
