#ifndef _CWINDOW_PROPERITES_
#define _CWINDOW_PROPERITES_

#include "PixmapsCache.h"
#include "SymLink.h"
#include "ThreadOp.h"


class CWindowProperites : public QDialog {
  Q_OBJECT
  private:
    PixmapsCache             * pxCache;
    QLabel                                                                                * labelNameH,
                                            * labelPath,                                 * labelPathH,
                                            * labelObject,                             * labelObjectH,
                                            * labelType,                                * labelTypeH,
                                            * labelMimeType,                      * labelMimeTypeH,
                                            * labelLastRead,                       * labelLastReadH,
                                            * labelSize,                                 * labelSizeH,
                                            * labelDescription,                     * labelDescriptionH,
                                            * labelDescrFromContents,      * labelDescrFromContentsH,
                                                                                                  * labelTargetH,
                                            * labelModified,                          * labelModifiedH,
                                            * labelCreated,                           * labelCreatedH,
                                                                                                  * labelFreeSpaceH,
                                             * labelHeaderInfo,
                                             * labelHeaderPermissions,
                                             * labelHeaderOwner,
                                             * labelHeaderSpace,
                                             * labelNotChangePermissions;

    QPushButton                * iconButton,
                                           * okButton, *cancelButton, *applyButton, *refreshButton,
                                           *recountButton, *stopRecountButton;

    QGroupBox                  * infoBox, *permissionBox, *moreBox, *idBox, *buttonsBox;

    QVBoxLayout               *mainLayout;
    QHBoxLayout               *infoHLayout, *permissionHLayout, *buttonsHLayout, *recountButtonsHLayout;
    QGridLayout                 *infoGridLayout, *permissionGridLayout, *moreGridLayout, *idGridLayout;
    QLineEdit                      *nameEdit, *idOwnerEdit, *idGroupEdit, *targetEdit;
    QList<QCheckBox*>    permissionCheck;
    QCheckBox                  *setAllPermission;
    QProgressBar               *freeSpace;
    Template FileTemplate;
    QFileInfo FileInfo;
    QList<QFileInfo> FileInfoList;
    QBitArray Permissions;
    QBitArray bitMask;
    int ID_Owner, ID_Group;
    QString Uids, Gids;

    QFont Font, BoldFont;
    QPalette epal, pal;

    QList<QString> lst;
    QTimer *timer;
    CThreadGS *threadGS;
    quint64 sizeData, countData, countFolders, countFiles, sd;
    quint64 countfolders, countfiles;
    QBitArray BitMask;    // 0 - symlink, 1 - file, 2 - directory, 3 - block, 4 - character, 5 - fifo, 6 - socket
    QDialog *Perm;
    CExcludeEvents *ExcludeEvents;

  public:
    CWindowProperites ( PixmapsCache*,  QFileInfo, QPalette, QColor, QFont, QWidget *wgt = 0 );
    CWindowProperites ( PixmapsCache*,  QList<QFileInfo>, QPalette, QColor, QFont, QWidget *wgt = 0 );
    ~CWindowProperites();

  private:
    void createDefaultWidget();
    void createDefaultWidgetFL();
    void createPermissionsTable();
    void countProcessForOne();
    void countProcessForList();
    void createIfSymLinkAndDir();
    void createIfNotSymLinkAndDir();
    void createIfSymLink();
    void createIfOther();
    void createIfNoObject();
    void createNoObjectList();
    void refreshPermissionsTable();
    void refreshFreeSpace();
    void refreshIfSymLinkAndDir();
    void refreshIfNotSymLinkAndDir();
    void refreshIfSymLink();
    void refreshIfOther();

    bool compareParametres();

  private slots:
    void refreshCountAndSize();
    void setOfAllCounts();
    void setOfAllCountsFL();
    void changedFields();
    void slotCancel();
    void slotRefresh();
    void setPermissionsFL();
    void recountSize();
    void recountSizeFL();
    void applyChanges();
    void applyChangePermissionFL();

};

#endif
