#include "../../Include/About.h"

CAbout :: CAbout (PixmapsCache *pxCache, QPalette palette, QWidget *wgt) : QDialog(wgt) {
  this->setPalette(palette);
  QPalette pal;
  pal.setBrush(QPalette::Base, QBrush(pxCache->getLogoBack()));
  pal.setBrush(QPalette::Window, QBrush(pxCache->getLogoBack()));
  mainLayout = new QVBoxLayout(this);
  mainIconLabel = new QLabel();
  mainTextLabel = new QLabel();
  mainTextLabel->setPalette(pal);
  mainTextLabel->setAutoFillBackground(true);
  mainTextLabel->setText("<b> <font size=5>Bathyscaphe</font><br><font size=4>" + tr("File manager") + "</font><br><font size=3>" + tr("version") + " 120120</font> </b>");
  headerLayout = new QHBoxLayout();
  headerLayout->setSpacing(0);
  tabWidget = new QTabWidget();
  Info = new QLabel();
  Contacts = new QLabel();
  Po = new QLabel();
  Thanks = new QLabel();
  Themes = new QLabel();
  tabWidget->addTab(Info, tr("About"));
  tabWidget->addTab(Po, tr("Used by"));
  tabWidget->addTab(Themes, tr("Themes"));
  tabWidget->addTab(Contacts, tr("Contacts"));
  tabWidget->addTab(Thanks, tr("Thanks"));
  buttonsLayout = new QHBoxLayout();
  closeButton = new QPushButton(*(pxCache->getIcon(191)), tr("Close"));

  headerLayout->addWidget(mainIconLabel);
  headerLayout->addWidget(mainTextLabel, 1);
  mainLayout->addLayout(headerLayout);
  mainLayout->addWidget(tabWidget);
  buttonsLayout->setStretch(0, 1);
  buttonsLayout->addWidget(closeButton);
  mainLayout->addLayout(buttonsLayout);

  mainIconLabel->setPixmap(pxCache->getLogo());

  Info->setText("<center>" +
  tr("Bathyscaphe - file manager for Linux and other *nix systems with <br> \
  open source code.<br>\
  It is intended for viewing and perform basic operations on <br>\
  files and directories - create, delete, copy, move, edit, access rights, etc.<br>\
  Supports various display modes (single-and two-pane view,<br>\
  as well as a directory tree view in the form of icons, list or a detailed list),<br>\
  Drag-and-Drop, 'hot' keys, the use of filters to display files with specific <br>\
  extensions or mime-types, as well as the installation of custom filters. <br>\
  It has built-in tools for viewing (and editing), text files, view graphics <br>\
  files of common formats, as well as HTML-files on a disk or a network. <br>\
  You can change and save settings - font sizes, colors and texture <br>\
  background images, themes and styles to 'fly'.<br>\
  Available in source and binary packages.") + "</center>");

  Po->setText(tr("The program is written in C + + c, using the Qt libraries from Nokia  <br> \
and libraries libmagic1. <br>\
Compiling with GCC v 4.4 or later.<br>\
To run the program, you must have Qt libraries 4.6.2 or later version <br>\
with the following modules: <br>\
QtCore <br>\
QtGui <br>\
QtSvg <br>\
QtNetwork <br>\
QtXml <br>\
QtWebkit <br>\
and libraries libmagic1 3.5 or later version <br>\
To compile programs from source code as required development packages. <br>\
Visit the repository of your distribution to install the necessary packages. <br>\
--------------------------------------------------------------------- <br>\
For more information, visit the following sites: <br>\
<a href = 'http://qt.nokia.com'>http://qt.nokia.com</a> <br>\
<a href = 'http://www.kde.org'>http://www.kde.org</a>"));
  Po->setOpenExternalLinks(true);


  Contacts->setText( tr("Web site:<br>\
<a href = 'http://bathyscaphe.ru'>http://bathyscaphe.ru</a><br>\
Here you can learn more about the project, download the latest<br>\
version of the theme, find news and more.<br> <br> \
--------------------------------------------------------------------------------<br><br> \
If you find errors and bugs in the program you want podelits <br>\
ideas or ask questions - contact on the soap:<br>\
E-mail: vas3362@ya.ru <br> <br> \
--------------------------------------------------------------------------------<br> <br> \
If you liked the project and you want to contribute to it, <br>\
go to the address <a href = 'http://bathyscaphe.ru/mecenat'>http://bathyscaphe.ru/mecenat</a> <br>\
and learn how to do it."));
  Contacts->setOpenExternalLinks(true);

  Themes->setText(tr("All subjects (icons, icons) represent the standard theme for KDE, <br>\
taken from the site and adapted for kde.org Bathycaphe. <br>\
All rights belong to their authors for themes to keep the original name. <br> <br> \
--------------------------------------------------------------------------- <br> <br>\
Visit <a href = 'http://www.kde.org'>http://www.kde.org</a> for more information."));
  Themes->setOpenExternalLinks(true);

  Thanks->setText(tr("Big Respect from Nokia for the library Qt, <br> \
as well as the creators of libmagic1. <br>\
Just thanks to everyone who creates a theme for KDE, as well as those who  <br>\
uchavstuet in developing and supporting KDE. <br>\
And a special thank you to all who assisted in the development of the project,  <br>\
is interested in and supports it."));
  Thanks->setOpenExternalLinks(true);

  connect (closeButton, SIGNAL(clicked()), SLOT(accept()));
  this->setMaximumWidth(600);
  exec();
  delete this;
}
