#include "../../Include/ImageViewerTool.h"

CImageViewerTool :: CImageViewerTool ( PixmapsCache *pxcache, QWidget * wgt) : CToolBar(wgt) {
  pxCache = pxcache;
  setIconSize(QSize(24, 24));

  PreviousButton = addAction(*(pxCache->getIcon(140)), tr("Previous image") );
  NextButton = addAction(*(pxCache->getIcon(141)), "Next image");
  addSeparator();
  RotateLeftButton = addAction(*(pxCache->getIcon(142)), tr("Rotate left"));
  RotateRightButton = addAction(*(pxCache->getIcon(143)), tr("Rotate right"));
  addSeparator();
  CloneHorizontalButton = addAction(*(pxCache->getIcon(144)), tr("Clone horizontal"));
  CloneVerticalButton = addAction(*(pxCache->getIcon(145)), tr("Clone vertical"));
  NegativeButton = addAction(*(pxCache->getIcon(146)), tr("Negative"));
  addSeparator();
  ScaleViewportButton = addAction(*(pxCache->getIcon(147)), tr("Scale image from viewport"));
  ScaleViewportButton->setCheckable(true);

  LeftLabel = new QLabel("0%");
  ScaleSlider = new QSlider(Qt::Horizontal);
  ScaleSlider->setRange(0, 100);
  RightLabel = new QLabel("100%");
  Layout.addWidget(LeftLabel);
  Layout.addWidget(ScaleSlider);
  Layout.addWidget(RightLabel);

  addSeparator();
  RefreshButton = addAction(*(pxCache->getIcon(148)), tr("Reload image"));

}

void CImageViewerTool :: setDirectory(QString dir) {
  Directory = dir;
}

void CImageViewerTool :: refreshTheme() {
  PreviousButton->setIcon(*(pxCache->getIcon(140)));
  NextButton->setIcon(*(pxCache->getIcon(141)));
  RotateLeftButton->setIcon(*(pxCache->getIcon(142)));
  RotateRightButton->setIcon(*(pxCache->getIcon(143)));
  CloneHorizontalButton->setIcon(*(pxCache->getIcon(144)));
  CloneVerticalButton->setIcon(*(pxCache->getIcon(145)));
  NegativeButton->setIcon(*(pxCache->getIcon(146)));
  ScaleViewportButton->setIcon(*(pxCache->getIcon(147)));
  RefreshButton->setIcon(*(pxCache->getIcon(148)));
}
