#include "../../Include/MainWidget.h"

MainWidget :: MainWidget (QWidget *wgt) : QWidget(wgt){
  readSettings();
  if ( Max ) showMaximized();
  else resize(Width, Height);
  SaveSettings = true;
}

void MainWidget :: readSettings(){
  QSettings settings;
  settings.beginGroup("Bathyscaphe/MainWidget");
  Width = settings.value("/Width", 1000).toInt();
  Height = settings.value("/Height", 600).toInt();
  Max = settings.value("/Maximized", false).toBool();
  settings.endGroup();
}

void MainWidget :: writeSettings(){
  if ( SaveSettings) {
    QSettings settings;
    settings.beginGroup("/Bathyscaphe/MainWidget");
    settings.setValue("/Width", Width);
    settings.setValue("/Height", Height);
    settings.setValue("/Maximized", this->isMaximized());
    settings.endGroup();
  }
}

void MainWidget :: setBackColor(QColor color){
  QPalette pal = this->palette();
  changeBackgroundPalette(&pal, color);
  setPalette(pal);
}

void MainWidget :: setFontColor(QColor color) {
  QPalette pal = this->palette();
  changeTextPalette(&pal, color);
  this->setPalette(pal);
}


void MainWidget :: resizeEvent(QResizeEvent *ev) {
  QWidget::resizeEvent(ev);
  Width = ev->size().width();
  Height = ev->size().height();
  emit newSize(this->geometry());
}
void MainWidget :: moveEvent(QMoveEvent *ev) {
  QWidget::moveEvent(ev);
  emit newSize(this->geometry());
}

MainWidget :: ~MainWidget(){
  writeSettings();
}
