#include "../../Include/Cvs.h"


CCvs :: CCvs(QObject *obj) : QObject(obj) {
#if defined(Q_OS_LINUX)
  B_PLATFORM = "lnx";
#elif defined (Q_OS_WIN32)
  B_PLATFORM = "wnd";
#else
  B_PLATFORM = "other";
#endif

  B_VERSION = 120120;
  B_SERVER = "www.bathyscaphe.ru";
  LoaderUpdates = new QHttp(this);
  buffer = new QBuffer();
  QString str = QLocale::system().name();
  QStringList lst = str.split("_");
  if ( lst.count() == 2 ) {
    B_LANGUAGE = lst[0];
  }
  else {
    B_LANGUAGE = "en";
  }
  uniqid = -3;

  connect (LoaderUpdates, SIGNAL(requestFinished(int, bool)), SLOT(startLoadingUpdates(int, bool)));
  connect (LoaderUpdates, SIGNAL(requestFinished(int, bool)), SLOT(finishLoadingUpdates(int, bool)));
}

 void CCvs :: connectToServer() {
 uniqid = LoaderUpdates->setHost(B_SERVER, 80);
}


void CCvs :: startLoadingUpdates(int id, bool ok) {
  if ( uniqid != id ) return;
  if ( id == uniqid  && !ok ) {
    buffer->open(QIODevice::WriteOnly);
    LoaderUpdates->get( "/index.html?targ=cvs&version=" +
                                           QString::number(B_VERSION) + "&platform=" +
                                            B_PLATFORM + "&language=" + B_LANGUAGE ,
                                            buffer);
  }
}

void CCvs :: finishLoadingUpdates(int id, bool ok) {
  if ( uniqid == id ) return;
  if ( id != uniqid && !ok ) {
    buffer->close();
    LoaderUpdates->blockSignals(true);
    LoaderUpdates->close();
    emit finishedUpdates(buffer, true);
  }
  else {
    buffer->close();
    LoaderUpdates->blockSignals(true);
    LoaderUpdates->close();
  }
}

void CCvs :: starting() {
  QTimer::singleShot(5000, this, SLOT(connectToServer()));
}

