#include "../../Include/MessageBox.h"

CMessageBox :: CMessageBox(PixmapsCache *pxcache, QWidget* wgt) : QDialog(wgt) {
  pxCache = pxcache;
  wid = NoType;
  setWindowIcon(*(pxCache->getMainIcon(3)));
  ExcludeEvents = new CExcludeEvents(82, this);
}

void CMessageBox :: createInputString() {
  wid = InputString;
  layout = new QGridLayout(this);
  lineedit1 = new QLineEdit();
  lineedit1->installEventFilter(ExcludeEvents);
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Ok"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));
  inform = new QLabel();
  layout->addWidget(inform, 0, 0, 1, 3);
  layout->addWidget(lineedit1, 1, 0, 1, 3);
  layout->addWidget(okButton, 2, 0 );
  layout->addWidget(cancelButton, 2, 2);
  lineedit1->setFocus();

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
  connect ( lineedit1, SIGNAL(returnPressed()), SLOT(returnOk()));
}

int CMessageBox :: execInputString(QString* buffer) {
  int n = QDialog::exec();
  if ( n == 1 ) {
      *buffer = lineedit1->text();
   }
   return n;
}

int CMessageBox :: execInputString(QString* string1, QString* string2) {
  int n = QDialog::exec();
  if ( n == 1 ) {
    *string1 = lineedit1->text();
     *string2 = lineedit2->text();
  }
  return n;
}

void CMessageBox :: createInputStringWithIcon(QPixmap Icon) {
  wid = InputWithIcon;
  layout = new QGridLayout(this);
  lineedit1 = new QLineEdit();
  lineedit1->installEventFilter(ExcludeEvents);
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Ok"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));
  inform = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);

  labelname1 = new QLabel();
  labelicon1 = new QLabel();
  labeldetals1 = new QLabel();
  box1 = new QGroupBox(tr("Target:"));
  box1->setAlignment(Qt::AlignLeft);
  QVBoxLayout  *gridbox1 = new QVBoxLayout(box1);
  QHBoxLayout *hgridbox1 = new QHBoxLayout();
  gridbox1->addWidget(labelname1);
  hgridbox1->addWidget(labelicon1);
  hgridbox1->addWidget(labeldetals1,2);
  gridbox1->addLayout(hgridbox1);

  layout->addWidget(icon, 0, 0);
  layout->addWidget(inform, 0, 1, 1, 2);
  layout->addWidget(box1, 1, 0, 1, 3);
  layout->addWidget(lineedit1, 2, 0, 1, 3);
  layout->addWidget(okButton, 3, 0 );
  layout->addWidget(cancelButton, 3, 2);
  lineedit1->setFocus();
  box1->hide();

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
  connect ( lineedit1, SIGNAL(returnPressed()), SLOT(returnOk()));
}

void CMessageBox :: createInputTwoString(QPixmap Icon) {
  wid = InputTwoString;
  layout = new QGridLayout(this);
  lineedit1 = new QLineEdit();
  lineedit2 = new QLineEdit();
  lineedit1->installEventFilter(ExcludeEvents);
  lineedit2->installEventFilter(ExcludeEvents);
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Ok"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));
  renameButton = new QPushButton();
  renameButton->setIcon(*(pxCache->getIcon(194)));
  inform = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);
  labelname2 = new QLabel();
  labeldetals2 = new QLabel();

  labelname1 = new QLabel();
  labelicon1 = new QLabel();
  labeldetals1 = new QLabel();
  box1 = new QGroupBox("Target:");
  box1->setAlignment(Qt::AlignLeft);
  QVBoxLayout  *gridbox1 = new QVBoxLayout(box1);
  QHBoxLayout *hgridbox1 = new QHBoxLayout();
  gridbox1->addWidget(labelname1);
  hgridbox1->addWidget(labelicon1);
  hgridbox1->addWidget(labeldetals1,2);
  gridbox1->addLayout(hgridbox1);

  layout->addWidget(icon, 0, 0);
  layout->addWidget(inform, 0, 1, 1, 2);
  layout->addWidget(box1, 1, 0, 1, 3);

  layout->addWidget(labelname2, 2, 0);
  layout->addWidget(lineedit1, 2, 1, 1, 2);
  layout->addWidget(labeldetals2, 3, 0);
  layout->addWidget(lineedit2, 3, 1, 1, 1);
  layout->addWidget(renameButton, 3, 2);
  layout->addWidget(okButton, 4, 0 );
  layout->addWidget(cancelButton, 4, 2);
  lineedit1->setFocus();
  box1->hide();

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
  connect ( renameButton, SIGNAL(clicked()), SLOT(selectFile()));
  connect ( lineedit1, SIGNAL(returnPressed()), SLOT(changeFocus()));
  connect ( lineedit2, SIGNAL(returnPressed()), SLOT(returnOk()));
}

void CMessageBox :: createInform( QPixmap Icon ) {
  wid = Inform;
  layout = new QGridLayout(this);
  inform = new QLabel();
  icon = new QLabel();
  detals = new QLabel();
  okButton = new QPushButton(*(pxCache->getIcon(191)), tr("Close"));
  icon->setPixmap(Icon);

  layout->addWidget(icon, 0, 0);
  layout->addWidget (inform,  0, 1, 1, 2);
  layout->addWidget(detals, 1, 0, 1, 3 );
  layout->addWidget(okButton, 2, 1, 1, 1);

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
}

void CMessageBox :: createWarningRemove ( QPixmap Icon ) {
  wid = WarningRemove;
  layout = new QGridLayout(this);
  inform = new QLabel();
  icon = new QLabel();
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Delete"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));
  icon->setPixmap(Icon);
  checkbox = new QCheckBox(tr("Do not show this message again."));
  checkbox->setChecked(false);
  textedit = new QTextEdit();
  textedit->installEventFilter(ExcludeEvents);
  textedit->setReadOnly(true);

  layout->addWidget(icon, 0, 0);
  layout->addWidget (inform,  0, 1, 1, 2);
  layout->addWidget(textedit, 1, 0, 1, 3);
  layout->addWidget(checkbox, 2, 0, 1, 3);
  layout->addWidget(okButton, 3, 0);
  layout->addWidget(cancelButton, 3, 2);

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
}

void CMessageBox :: createResultOperate(QPixmap Icon) {
  wid = ResultOperate;
  layout = new QGridLayout(this);
  inform = new QLabel();
  icon = new QLabel();
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Close"));
  icon->setPixmap(Icon);
  treewidget = new QTreeWidget();
  treewidget->setIconSize(QSize(24, 24));
  detals = new QLabel();
  QStringList lbl;
  lbl << tr("Object") << tr("Error") << tr("System Message");
  treewidget->setHeaderLabels(lbl);
  treewidget->setRootIsDecorated(false);

  layout->addWidget(icon, 0, 0);
  layout->addWidget (inform,  0, 1, 1, 2);
  layout->addWidget (treewidget, 1, 0, 1, 3);
  layout->addWidget (detals, 2, 0, 1, 3);
  layout->addWidget(cancelButton, 3, 1);

  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
}

void CMessageBox :: createWarningCopy(QPixmap Icon, bool write) {
  layout = new QGridLayout(this);
  inform = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);
  labelname1 = new QLabel();
  labelicon1 = new QLabel();
  labeldetals1 = new QLabel();
  labelname2 = new QLabel();
  labelicon2 = new QLabel();
  labeldetals2 = new QLabel();
  lineedit1 = new QLineEdit();
  lineedit1->installEventFilter(ExcludeEvents);

  renameButton = new QPushButton(*(pxCache->getIcon(195)), tr("Rename"));
  retryButton = new QPushButton(*(pxCache->getIcon(192)), tr("Retry"));
  retryAllButton = new QPushButton(*(pxCache->getIcon(192)),  tr("Retry All"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Abort Operation"));
  if ( write ) {
     writeButton = new QPushButton(*(pxCache->getIcon(193)), tr("Write"));
     writeAllButton = new QPushButton(*(pxCache->getIcon(193)), tr("Write All"));
     wid = WarningCopyWithWrite;
  }
  else wid = WarningCopy;

  box1 = new QGroupBox(tr("Source:"));
  box2 = new QGroupBox(tr("Target:"));
  box1->setAlignment(Qt::AlignLeft);
  box2->setAlignment(Qt::AlignLeft);

  QVBoxLayout *gridbox1 = new QVBoxLayout(box1);
  QVBoxLayout *gridbox2 = new QVBoxLayout(box2);
  QHBoxLayout *hgridbox1 = new QHBoxLayout();
  QHBoxLayout *hgridbox2 = new QHBoxLayout();

  gridbox1->addWidget(labelname1);
  hgridbox1->addWidget(labelicon1);
  hgridbox1->addWidget(labeldetals1,2);
  gridbox1->addLayout(hgridbox1);
  gridbox2->addWidget(labelname2);
  hgridbox2->addWidget(labelicon2);
  hgridbox2->addWidget(labeldetals2,4);
  gridbox2->addLayout(hgridbox2);


  layout->addWidget(icon,0,0);
  layout->addWidget(inform, 0,1,1,3);
  layout->addWidget(box1, 2,0,1,4);
  layout->addWidget(box2, 3,0,1,4);
  layout->addWidget(lineedit1, 5,0,1,3);
  layout->addWidget(renameButton, 5, 3);
  if ( write ) {
    layout->addWidget(writeButton, 6,0,1,2);
    layout->addWidget(writeAllButton, 6,2,1,2);
    layout->addWidget(retryButton, 7,0,1,2);
    layout->addWidget(retryAllButton, 7,2,1,2);
    layout->addWidget(cancelButton, 8,1,1,2);

    connect (cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
    connect (retryButton, SIGNAL(clicked()), SLOT(returnRetry()));
    connect (retryAllButton, SIGNAL(clicked()), SLOT(returnRetryAll()));
    connect (writeButton, SIGNAL(clicked()), SLOT(returnWrite()));
    connect (writeAllButton, SIGNAL(clicked()), SLOT(returnWriteAll()));
    connect (renameButton, SIGNAL(clicked()), SLOT(returnOk()));
    connect (lineedit1, SIGNAL(textChanged(QString)), SLOT(wasTextChanged(QString)));
    connect ( lineedit1, SIGNAL(returnPressed()), SLOT(wasReturnPressed()));

  }
  else {
    layout->addWidget(retryButton, 6,0,1,2);
    layout->addWidget(retryAllButton, 6,2,1,2);
    layout->addWidget(cancelButton, 7,1,1,2);

    connect (cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
    connect (retryButton, SIGNAL(clicked()), SLOT(returnRetry()));
    connect (retryAllButton, SIGNAL(clicked()), SLOT(returnRetryAll()));
    connect (renameButton, SIGNAL(clicked()), SLOT(returnOk()));
    connect ( lineedit1, SIGNAL(textChanged(QString)), SLOT(changeRenameEnabled(QString)));
    connect ( lineedit1, SIGNAL(returnPressed()), SLOT(wasReturnPressed()));
  }
}

void CMessageBox :: createWarningCopyOnIt(QPixmap Icon) {
  wid = WarningCopyOnIt;
  layout = new QGridLayout(this);
  inform = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);
  labelname1 = new QLabel();
  labelicon1 = new QLabel();
  labeldetals1 = new QLabel();
  lineedit1 = new QLineEdit();
  lineedit1->installEventFilter(ExcludeEvents);

  renameButton = new QPushButton(*(pxCache->getIcon(195)), tr("Rename"));
  retryButton = new QPushButton(*(pxCache->getIcon(192)), tr("Retry"));
  retryAllButton = new QPushButton(*(pxCache->getIcon(192)), tr("Retry All"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Abort Operation"));

  box1 = new QGroupBox(tr("Source:"));
  box1->setAlignment(Qt::AlignLeft);
  QVBoxLayout *gridbox1 = new QVBoxLayout(box1);
  QHBoxLayout *hgridbox1 = new QHBoxLayout();

  gridbox1->addWidget(labelname1);
  hgridbox1->addWidget(labelicon1);
  hgridbox1->addWidget(labeldetals1,2);
  gridbox1->addLayout(hgridbox1);

  layout->addWidget(icon,0,0);
  layout->addWidget(inform, 0,1,1,3);
  layout->addWidget(box1, 1,0,1,4);
  layout->addWidget(lineedit1, 2,0,1,3);
  layout->addWidget(renameButton, 2, 3);
  layout->addWidget(retryButton, 3,0,1,2);
  layout->addWidget(retryAllButton, 3, 2, 1, 2);
  layout->addWidget(cancelButton, 4,1,1,2);

  connect (cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
  connect (retryButton, SIGNAL(clicked()), SLOT(returnRetry()));
  connect (renameButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect (retryAllButton, SIGNAL(clicked()), SLOT(returnRetryAll()));
  connect ( lineedit1, SIGNAL(textChanged(QString)), SLOT(changeRenameEnabled(QString)));
  connect ( lineedit1, SIGNAL(returnPressed()), SLOT(wasReturnPressed()));
}

void CMessageBox :: createQuestion(QPixmap Icon) {
  wid = Question;
  layout = new QGridLayout(this);
  inform = new QLabel();
  detals = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Yes"));
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));

  layout->addWidget(icon, 0, 0);
  layout->addWidget(inform, 0, 1, 1, 2);
  layout->addWidget(detals, 1, 0, 1, 3);
  layout->addWidget(okButton, 2, 0);
  layout->addWidget(cancelButton, 2, 2);

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
}

void CMessageBox :: createSaveQuestion(QPixmap Icon) {
  wid = SaveQuestion;
  layout = new QGridLayout(this);
  inform = new QLabel();
  detals = new QLabel();
  icon = new QLabel();
  icon->setPixmap(Icon);
  okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Save"));
  renameButton = new QPushButton(*(pxCache->getIcon(193)), tr("Save As") + " ...");
  cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Not save"));

  layout->addWidget(icon, 0, 0);
  layout->addWidget(inform, 0, 1, 1, 2);
  layout->addWidget(detals, 1, 0, 1, 3);
  layout->addWidget(okButton, 2, 0);
  layout->addWidget(renameButton, 2, 1);
  layout->addWidget(cancelButton, 2, 2);

  connect ( okButton, SIGNAL(clicked()), SLOT(returnOk()));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(returnCancel()));
  connect (renameButton, SIGNAL(clicked()), SLOT(returnRename()));
}


void CMessageBox :: setCastomPalette(QPalette pal, QColor color) {
  if ( wid == NoType ) return;
  QPalette bpal = pal;
  changeBackgroundPalette(&bpal, darkerColor(color, 40));
  this->setPalette(bpal);
  if ( wid == InputString || wid == InputWithIcon )  lineedit1->setPalette(pal);
  if ( wid == WarningRemove ) {
    textedit->setPalette(pal);
    textedit->verticalScrollBar()->setPalette(bpal);
  }
  if ( wid == WarningCopy || wid == WarningCopyOnIt || wid == WarningCopyWithWrite) lineedit1->setPalette(pal);
  if ( wid == ResultOperate) {
    treewidget->setPalette(pal);
    treewidget->verticalScrollBar()->setPalette(bpal);
    treewidget->horizontalScrollBar()->setPalette(bpal);
  }
  if ( wid == InputTwoString) {
    lineedit1->setPalette(pal);
    lineedit2->setPalette(pal);
  }
}

void CMessageBox :: setTextIntoWrite(QString text) {
  if ( wid == WarningCopyWithWrite ) {
    lineedit1->blockSignals(true);
    lineedit1->setText(text);
    Text = text;
    lineedit1->blockSignals(false);
    writeButton->setEnabled(true);
    writeAllButton->setEnabled(true);
    renameButton->setEnabled(false);
  }
  else {
    if ( wid == WarningCopyOnIt || wid == WarningCopy) {
      lineedit1->blockSignals(true);
      lineedit1->setText(text);
      Text = text;
      lineedit1->blockSignals(false);
      renameButton->setEnabled(false);
    }
  }
}

void CMessageBox :: wasTextChanged(QString text) {
  if ( wid == WarningCopyWithWrite ) {
    if ( Text == text) {
      writeButton->setEnabled(true);
      writeAllButton->setEnabled(true);
      renameButton->setEnabled(false);
    }
    else {
      writeButton->setEnabled(false);
      writeAllButton->setEnabled(false);
      renameButton->setEnabled(true);
    }
  }
  else {
    if ( wid == WarningCopyOnIt || wid == WarningCopy) {
      if ( Text == text ) renameButton->setEnabled(false);
        else renameButton->setEnabled(true);
    }
  }
}

void CMessageBox :: wasReturnPressed() {
  if ( Text == lineedit1->text()) return;
    else returnOk();
}

void CMessageBox :: changeRenameEnabled(QString text) {
  if (Text == text) renameButton->setEnabled(false);
    else renameButton->setEnabled(true);
}

void CMessageBox ::selectFile() {
  QString str = QFileDialog::getOpenFileName(0, tr("Select file or directory") + " - Batiscaff", dir);
  if ( str != "") {
    if ( lineedit1->text() == "" ) {
      QFileInfo finf(str);
      lineedit1->setText(finf.fileName());
      lineedit2->setText(str);
    }
    else {
      lineedit2->setText(str);
    }
  }
}

void CMessageBox :: changeFocus() {
  lineedit2->setFocus();
}
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

CCopySettings :: CCopySettings(QBitArray* bitState, bool* query, QWidget *wgt) : QDialog(wgt) {
  mainlayout = new QVBoxLayout(this);
  headerlabel = new QLabel("<h3 align=center>" + tr("Settings From Disk Operation") + "</h3>");
  mainlayout->addWidget(headerlabel);
  QList<QString> lbl;
  lbl                 <<            "<h4 align=center>" + tr("When you delete files and directories") + ":</h4>"
                       <<            "<h4 align=center>" + tr("if when copy file in target catalog  already exists file with this name, than") + ":</h4>"
                       <<            "<h4 align=center>" + tr("if when copy file in target catalog  already exists folder with this name, than") + ":</h4>"
                       <<            "<h4 align=center>" + tr("if when copy directory in target catalog  already exists file with this name, than") + ":</h4>"
                       <<            "<h4 align=center>" + tr("if when copy directory in target catalog  already exists folder wiyh this name, than") + ":</h4>";

  for ( int i = 0; i < 5; ++i ) {
    QGroupBox * box = new QGroupBox();
    boxes << box;
    QLabel *label = new QLabel(lbl[i]);
    labels << label;
    QVBoxLayout *lay = new QVBoxLayout();
    layouts << lay;
    lay->addWidget(label);
    box->setLayout(lay);
    mainlayout->addWidget(box);
  }
  lbl.clear();
  lbl                <<                 tr("Request confirmation")                            //         0
                      <<                 tr("Do not ask")                                               //         1
                      <<                 tr("Request for further instructions")             //         2
                      <<                 tr("Retry")                                                        //         3
                      <<                 tr("Otherwrite")                                               //         4
                      <<                 tr("Request for further instructions")           //         5
                      <<                 tr("Retry")                                                       //         6
                      <<                 tr("Request for further instructions")          //         7
                      <<                 tr("Retry")                                                       //         8
                      <<                 tr("Otherwrite")                                              //         9
                      <<                 tr("Request for further instructions")          //         10
                      <<                 tr("Retry")                                                      //         11
                      <<                 tr("Write source directory to this");             //         12
  for ( int i = 0; i < 13; ++i) {
    QRadioButton *radio = new QRadioButton(lbl[i]);
    radiobuttons << radio;
  }

  checkbox = new QCheckBox(tr("Do not ask stupid questions"));
  checkbox->setChecked(*query);

  layouts[0]->addWidget(radiobuttons[0]);
  layouts[0]->addWidget(radiobuttons[1]);
  layouts[1]->addWidget(radiobuttons[2]);
  layouts[1]->addWidget(radiobuttons[3]);
  layouts[1]->addWidget(radiobuttons[4]);
  layouts[2]->addWidget(radiobuttons[5]);
  layouts[2]->addWidget(radiobuttons[6]);
  layouts[3]->addWidget(radiobuttons[7]);
  layouts[3]->addWidget(radiobuttons[8]);
  layouts[3]->addWidget(radiobuttons[9]);
  layouts[4]->addWidget(radiobuttons[10]);
  layouts[4]->addWidget(radiobuttons[11]);
  layouts[4]->addWidget(radiobuttons[12]);

  for ( int i = 0; i < 13; ++i) {
    radiobuttons[i]->setChecked(bitState->testBit(i));
  }

  mainlayout->addWidget(checkbox);
  if (! checkbox->isChecked()) {
    for ( int i = 0; i < 5; ++i ) {
      boxes[i]->setEnabled(false);
    }
  }

  close = new QPushButton("Close");
  mainlayout->addWidget(close);

  connect ( checkbox, SIGNAL(clicked()), SLOT(changeAll()));
  connect ( close, SIGNAL(clicked()), SLOT(end()));

  changeAll();
}

void CCopySettings :: exec(QBitArray* bitState, bool* query, bool *showwarningremove) {
  QDialog::exec();
  for ( int i = 0; i < 13; ++i ) {
    bitState->setBit(i, radiobuttons[i]->isChecked());
  }
  *query = checkbox->isChecked();
  if ( bitState->testBit(0)) *showwarningremove = true;
  else *showwarningremove = false;
}

void CCopySettings :: changeAll() {
  if ( !checkbox->isChecked()) {
    for ( int i = 0; i < 5; ++i ) {
      boxes[i]->setEnabled(true);
    }
  }
  else {
    radiobuttons[1]->setChecked(true);
    radiobuttons[4]->setChecked(true);
    radiobuttons[6]->setChecked(true);
    radiobuttons[9]->setChecked(true);
    radiobuttons[12]->setChecked(true);
    for ( int i = 0; i < 5; ++i ) {
      boxes[i]->setEnabled(false);
    }
  }
}

void CCopySettings :: end() {
  QDialog::done(1);
}
