#include "../../Include/Palette.h"

QColor darkerColor (QColor color, int coeff) {
  int red, green, blue;
  color.getRgb (&red, &green, &blue);
  if (red >= coeff + 10) red = red - coeff; else red = red + coeff;
  if (green >= coeff + 10) green = green - coeff; else green = green + coeff;
  if (blue >= coeff + 10) blue = blue - coeff; else blue = blue + coeff;
  color.setRgb (red, green, blue);
  return color;
}

QColor lighterColor (QColor color, int coeff) {
  int red, green, blue;
  color.getRgb (&red, &green, &blue);
  if (red <= 255 - coeff - 10) red = red + coeff; else red = red - coeff;
  if (green <= 255 - coeff - 10) green = green + coeff; else green = green - coeff;
  if (blue <= 255 - coeff - 10) blue = blue + coeff; else blue = blue - coeff;
  color.setRgb (red, green, blue);
  return color;
}

QColor contrastColor (QColor color) {
  int red, green, blue;
  color.getRgb (&red, &green, &blue);
  red = 255 - red;
  green = 255 - green;
  blue = 255 - blue;
  color.setRgb(red, green, blue);
  return color;
}

QPalette* changeBackgroundPalette(QPalette *palette, QColor bcolor) {
  palette->setColor(QPalette::Normal, QPalette::Window, bcolor);
  palette->setColor(QPalette::Normal, QPalette::Base, bcolor);
  palette->setColor(QPalette::Normal, QPalette::Button, darkerColor(bcolor, 30));
  palette->setColor(QPalette::Normal, QPalette::Light, darkerColor(bcolor, 10));
  palette->setColor(QPalette::Normal, QPalette::Midlight, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Normal, QPalette::Dark, darkerColor(bcolor, 60));
  palette->setColor(QPalette::Normal, QPalette::Mid, darkerColor(bcolor, 40));
  palette->setColor(QPalette::Normal, QPalette::Shadow, darkerColor(bcolor, 100));
  palette->setColor(QPalette::Normal, QPalette::BrightText, lighterColor(bcolor, 30));
  palette->setColor(QPalette::Normal, QPalette::Highlight, contrastColor(bcolor));
  palette->setColor(QPalette::Normal, QPalette::AlternateBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Normal, QPalette::ToolTipBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Normal, QPalette::HighlightedText, bcolor);

  palette->setColor(QPalette::Disabled, QPalette::AlternateBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Disabled, QPalette::ToolTipBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Disabled, QPalette::Button, darkerColor(bcolor, 10));
  palette->setColor(QPalette::Disabled, QPalette::Base, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Disabled, QPalette::Window, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Disabled, QPalette::Light, darkerColor(bcolor, 10));
  palette->setColor(QPalette::Disabled, QPalette::Midlight, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Disabled, QPalette::Dark, darkerColor(bcolor, 60));
  palette->setColor(QPalette::Disabled, QPalette::Mid, darkerColor(bcolor, 40));
  palette->setColor(QPalette::Disabled, QPalette::Shadow, darkerColor(bcolor, 100));
  palette->setColor(QPalette::Disabled, QPalette::BrightText, lighterColor(bcolor, 30));
  palette->setColor(QPalette::Disabled, QPalette::Highlight, darkerColor(contrastColor(bcolor), 20));

  palette->setColor(QPalette::Inactive, QPalette::AlternateBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Inactive, QPalette::ToolTipBase, darkerColor(contrastColor(bcolor), 20));
  palette->setColor(QPalette::Inactive, QPalette::Button, darkerColor(bcolor, 10));
  palette->setColor(QPalette::Inactive, QPalette::Base, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Inactive, QPalette::Window, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Inactive, QPalette::Light, darkerColor(bcolor, 10));
  palette->setColor(QPalette::Inactive, QPalette::Midlight, lighterColor(bcolor, 10));
  palette->setColor(QPalette::Inactive, QPalette::Dark, darkerColor(bcolor, 60));
  palette->setColor(QPalette::Inactive, QPalette::Mid, darkerColor(bcolor, 40));
  palette->setColor(QPalette::Inactive, QPalette::Shadow, darkerColor(bcolor, 100));
  palette->setColor(QPalette::Inactive, QPalette::BrightText, lighterColor(bcolor, 30));
  palette->setColor(QPalette::Inactive, QPalette::Highlight, darkerColor(contrastColor(bcolor), 20));
  return palette;
}

QPalette*  changeTextPalette(QPalette *palette, QColor bcolor) {
  palette->setColor(QPalette::Normal, QPalette::WindowText, bcolor);
  palette->setColor(QPalette::Normal, QPalette::Text, bcolor);
  palette->setColor(QPalette::Normal, QPalette::ButtonText, darkerColor(bcolor, 20));
  palette->setColor(QPalette::Disabled, QPalette::ButtonText, lighterColor(bcolor, 50));
  palette->setColor(QPalette::Disabled, QPalette::Text, lighterColor(bcolor, 50));
  palette->setColor(QPalette::Disabled, QPalette::WindowText, lighterColor(bcolor, 50));
  palette->setColor(QPalette::Inactive, QPalette::ButtonText, lighterColor(bcolor, 20));
  palette->setColor(QPalette::Inactive, QPalette::Text, lighterColor(bcolor, 20));
  palette->setColor(QPalette::Inactive, QPalette::WindowText, lighterColor(bcolor, 20));
  return palette;
}

