#include "../../Include/ThreadAreaIcon.h"

CThreadAreaIcon :: CThreadAreaIcon(ReserveCache *cache, QList<QFileInfo> *finf) : QThread() {
  pxCache = cache;
  listdrives = QDir::drives();
  fileinfolist = finf;
  execute = false;
}

void CThreadAreaIcon :: setData (QBitArray *biticon, QChar c, int * startE, int *endE) {
  bitIcon = biticon;
  wgt = c;
  startElement = startE;
  endElement = endE;
}

void CThreadAreaIcon :: run() {
  QFileInfo fileinfo, linktoinfo;
  QString linkto;
  execute = true;
  if ( wgt == 'L' || wgt == 'I' ) {
    int  index, flag, startElement_t, endElement_t;
    QString descr;
    while(true) {
      startElement_t = *startElement;
      endElement_t = *endElement;
      for ( int i = startElement_t; i <= endElement_t; ++i ) {
          if ( startElement_t != *startElement || endElement_t != *endElement) {
              break;
          }
          if (!execute) return;
          if ( bitIcon->testBit(i)) continue;
          fileinfo = fileinfolist->value(i);
          if ( fileinfo.isSymLink()) {
            link = true;
            linkto = fileinfo.readLink();
            linktoinfo.setFile(linkto);
            while (linktoinfo.isSymLink()) { linkto = linktoinfo.readLink(); linktoinfo.setFile(linkto); }
            if ( linktoinfo.exists()) {
                if ( linktoinfo.isDir()) {
                  index = 2;
                  flag = 0;
                  if ( linktoinfo.isRoot()) index = 0;
                  if ( linktoinfo.absoluteFilePath() == QDir::homePath()) index = 1;
                  if ( listdrives.contains(linktoinfo)) index = 3;
                  if ( linktoinfo.isHidden()) index = 4;
                  emit pixmapElement ( i, index, flag, link);
                  continue;
                }
                else {
                  pxCache->getIndexIcon(&linktoinfo, &descr, &index, &flag);
                  emit pixmapElement ( i, index, flag, link);
                  continue;
                }
            }
             else {
               index = 113;
               flag = 0;
               emit pixmapElement ( i, index, flag, link);
               continue;
             }
           }
          else {
              link = false;
              if ( fileinfo.isDir()) {
                index = 2;
                flag = 0;
                if ( fileinfo.isRoot())  index = 0;
                if ( fileinfo.absoluteFilePath() == QDir::homePath())  index = 1;
                if ( listdrives.contains(fileinfo))  index = 3;
                if ( fileinfo.isHidden())  index = 4;
                emit pixmapElement ( i, index, flag, link);
                continue;
              }
              else {
                pxCache->getIndexIcon(&fileinfo, &descr, &index, &flag);
                emit pixmapElement ( i, index, flag, link);
                continue;
              }
          }
      }
    }
  }

  if ( wgt == 'T' ) {
    QDir dir;
    quint64 fsize;
    int i, index, flag, startElement_t, endElement_t;;
    QString descr, size, lastm;
    QList<QString> label;
    label << tr("byte(s)") << tr("Kb") << tr("Mb") << tr("Gb") << tr("Tb");
    while(true) {
        startElement_t = *startElement;
        endElement_t = *endElement;
        for ( int n = startElement_t; n <= endElement_t; ++n ) {
            if ( startElement_t != *startElement || endElement_t != *endElement) {
                break;
            }
            if (!execute) return;
            if ( bitIcon->testBit(n)) continue;
            fileinfo = fileinfolist->value(n);
            if ( fileinfo.isSymLink()) {
              linkto = fileinfo.readLink();
              linktoinfo.setFile(linkto);
              while (linktoinfo.isSymLink()) { linkto = linktoinfo.readLink(); linktoinfo.setFile(linkto); }
              if ( linktoinfo.exists()) {
                  if ( linktoinfo.isDir()) {
                      index = 2;
                      flag = 0;
                      if ( linktoinfo.isRoot())  index = 0;
                      if ( linktoinfo.absoluteFilePath() == QDir::homePath())  index = 1;
                      if ( listdrives.contains(linktoinfo))  index = 3;
                      if ( linktoinfo.isHidden())  index = 4;
                      descr =  tr("link to catalog");
                      size = QString::number(countDir(linktoinfo.absoluteFilePath())) + " " + tr("element(s)");
                      lastm = linktoinfo.lastModified().toString("dd.MM.yy hh:mm");
                      emit pixmapElement(n, index, flag, descr, size, lastm, true);
                      continue;
                    }
                    else {
                      pxCache->getIndexIcon(&linktoinfo, &descr, &index, &flag);
                      fsize = linktoinfo.size();                                                 //   установить размер
                      for (  i = 0; i < 5; i++ ) {
                        if ( fsize < 1000 ) break;
                        fsize = fsize / 1000;
                      }
                      descr = tr("link to") + " " + descr;
                      size =  QString::number(fsize) + " " + label[i];
                      lastm =  linktoinfo.lastModified().toString("dd.MM.yy hh:mm");
                      emit pixmapElement(n, index, flag, descr, size, lastm, true);
                      continue;
                  }
              }
              else {
                    index = 113;
                    flag = 0;
                    descr = tr("broken link");
                    if ( lstat(fileinfo.absoluteFilePath().toLocal8Bit(), &sb) != -1) {
                    size = QString::number(sb.st_size) + " " + tr("byte");
                    lastm = QDateTime::fromTime_t(sb.st_mtime).toString("dd.MM.yy hh:mm");
                    }
                    else {
                    size = tr("0 bytes");
                    lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
                    }
                    emit pixmapElement(n, index, flag, descr, size, lastm, true);
                    continue;
                  }
            }
            else {
              if ( fileinfo.isDir()) {
                descr = tr("catalog");
                index = 2;
                flag = 0;
                if ( fileinfo.isRoot()) { index = 0; descr = tr("Root catalog"); }
                if ( fileinfo.absoluteFilePath() == QDir::homePath()) { index = 1; descr = tr("Home catalog"); }
                if ( listdrives.contains(fileinfo)) { index = 3; descr = tr("Drive"); }
                if ( fileinfo.isHidden()) { index = 4; descr = tr("Catalog"); }
//                dir.setPath(fileinfo.absoluteFilePath());
                size = QString::number(countDir(fileinfo.absoluteFilePath())) + " " + tr("element(s)");
                lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
                emit pixmapElement(n, index, flag, descr, size, lastm, false);
                continue;
              }
              else {
                  pxCache->getIndexIcon(&fileinfo, &descr, &index, &flag);
                  fsize = fileinfo.size();                                                 //   установить размер
                  for (  i = 0; i < 5; i++ ) {
                    if ( fsize < 1000 ) break;
                    fsize = fsize / 1000;
                  }
                  size = QString::number(fsize) + " " + label[i];
                  lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
                  emit pixmapElement(n, index, flag, descr, size, lastm, false);
                  continue;
              }
            }
          }
      }
    }
}
