#include "../../Include/ThreadIcon.h"

CThreadIcon :: CThreadIcon(ReserveCache *cache, QList<QFileInfo> *finf) : QThread() {
  pxCache = cache;
  listdrives = QDir::drives();
  fileinfolist = finf;
  execute = false;
}

void CThreadIcon :: setData ( QBitArray *biticon, QChar c) {
  bitIcon = biticon;
  wgt = c;
  link = false;
}

void CThreadIcon :: run() {
  QFileInfo fileinfo, linktoinfo;
  QString linkto;
  execute = true;
  if ( wgt == 'L' || wgt == 'I' ) {
    int index_item = 0, index, flag;
    QString descr;
    foreach ( fileinfo, *fileinfolist ) {
        if ( bitIcon->testBit(index_item)) {
          ++index_item;
          continue;
        }
        if (!execute) return;
        if ( fileinfo.isSymLink()) {
          link = true;
          linkto = fileinfo.readLink();
          linktoinfo.setFile(linkto);
          while (linktoinfo.isSymLink()) { linkto = linktoinfo.readLink(); linktoinfo.setFile(linkto); }
          if ( linktoinfo.exists()) {
              if ( linktoinfo.isDir()) {
                index = 2;
                flag = 0;
                if ( linktoinfo.isRoot())  index = 0;
                if ( linktoinfo.absoluteFilePath() == QDir::homePath()) index = 1;
                if ( listdrives.contains(linktoinfo)) index = 3;
                if ( linktoinfo.isHidden()) index = 4;
                emit pixmapElement ( index_item, index, flag, link);
                ++index_item;
                continue;
              }
              else {
                pxCache->getIndexIcon(&linktoinfo, &descr, &index, &flag);
                emit pixmapElement ( index_item, index, flag, link);
                ++index_item;
                continue;
              }
          }
          else {
             index = 113;
             flag = 0;
             emit pixmapElement ( index_item, index, flag, link);
             ++index_item;
             continue;
          }
        }
        else {
            link = false;
            if ( fileinfo.isDir()) {
              index = 2;
              flag = 0;
              if ( fileinfo.isRoot())  index = 0;
              if ( fileinfo.absoluteFilePath() == QDir::homePath())  index = 1;
              if ( listdrives.contains(fileinfo))  index = 3;
              if ( fileinfo.isHidden())  index = 4;
              emit pixmapElement ( index_item, index, flag, link);
              ++index_item;
              continue;
            }
            else {
              pxCache->getIndexIcon(&fileinfo, &descr, &index, &flag);
              emit pixmapElement ( index_item, index, flag, link);
              ++index_item;
              continue;
            }
        }
    }
  }

  if ( wgt == 'T' ) {
    QDir dir;
    quint64 fsize;
    int i, index_item = 0, index, flag;
    QString descr, size, lastm;
    QList<QString> label;
    label << tr("byte(s)") << tr("Kb") << tr("Mb") << tr("Gb") << tr("Tb");
    foreach ( fileinfo, *fileinfolist ) {
        if ( bitIcon->testBit(index_item)) {
          ++index_item;
          continue;
        }
        if (!execute) return;
        if ( fileinfo.isSymLink()) {
          linkto = fileinfo.readLink();
          linktoinfo.setFile(linkto);
          while (linktoinfo.isSymLink()) { linkto = linktoinfo.readLink(); linktoinfo.setFile(linkto); }
          if ( linktoinfo.exists()) {
              if ( linktoinfo.isDir()) {
                  index = 2;
                  flag = 0;
                  if ( linktoinfo.isRoot())  index = 0;
                  if ( linktoinfo.absoluteFilePath() == QDir::homePath())  index = 1;
                  if ( listdrives.contains(linktoinfo))  index = 3;
                  if ( linktoinfo.isHidden())  index = 4;
                  descr =  tr("link to catalog");
                  size = QString::number(countDir(linktoinfo.absoluteFilePath())) + " " + tr("element(s)");
                  lastm = linktoinfo.lastModified().toString("dd.MM.yy hh:mm");
                  emit pixmapElement(index_item, index, flag, descr, size, lastm, true);
                  ++index_item;
                  continue;
                }
                else {
                  pxCache->getIndexIcon(&linktoinfo, &descr, &index, &flag);
                  fsize = linktoinfo.size();                                                 //   установить размер
                  for (  i = 0; i < 5; i++ ) {
                    if ( fsize < 1000 ) break;
                    fsize = fsize / 1000;
                  }
                  descr = tr("link to") + " " + descr;
                  size =  QString::number(fsize) + " " + label[i];
                  lastm =  linktoinfo.lastModified().toString("dd.MM.yy hh:mm");
                  emit pixmapElement(index_item, index, flag, descr, size, lastm, true);
                  ++index_item;
                  continue;
              }
          }
          else {
                index = 113;
                flag = 0;
                descr = tr("broken link");
                if ( lstat(fileinfo.absoluteFilePath().toLocal8Bit(), &sb) != -1) {
                 size = QString::number(sb.st_size) + " " + tr("byte");
                 lastm = QDateTime::fromTime_t(sb.st_mtime).toString("dd.MM.yy hh:mm");
                }
                else {
                 size = "0 bytes";
                 lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
                }
                emit pixmapElement(index_item, index, flag, descr, size, lastm, true);
                ++index_item;
                continue;
              }
        }
        else {
          if ( fileinfo.isDir()) {
            descr = tr("catalog");
            index = 2;
            flag = 0;
            if ( fileinfo.isRoot()) { index = 0; descr = tr("Root catalog"); }
            if ( fileinfo.absoluteFilePath() == QDir::homePath()) { index = 1; descr = tr("Home catalog"); }
            if ( listdrives.contains(fileinfo)) { index = 3; descr = tr("Drive"); }
            if ( fileinfo.isHidden()) { index = 4; descr = tr("Catalog"); }
            size = QString::number(countDir(fileinfo.absoluteFilePath())) + " " + tr("element(s)");
            lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
            emit pixmapElement(index_item, index, flag, descr, size, lastm, false);
            ++index_item;
            continue;
          }
          else {
              pxCache->getIndexIcon(&fileinfo, &descr, &index, &flag);
              fsize = fileinfo.size();                                                 //   установить размер
              for (  i = 0; i < 5; i++ ) {
                if ( fsize < 1000 ) break;
                fsize = fsize / 1000;
              }
              size = QString::number(fsize) + " " + label[i];
              lastm = fileinfo.lastModified().toString("dd.MM.yy hh:mm");
              emit pixmapElement(index_item, index, flag, descr, size, lastm, false);
              ++index_item;
              continue;
          }
        }
      }
  }
  emit quitSubThread();
}
