#include "../../Include/PixmapsCache.h"
#include "../../Include/Stat.h"

PixmapsCache :: PixmapsCache( char ** argv, ReserveCache *cache1, ReserveCache *cache2,
                                                                                  ReserveCache * cache3, ReserveCache *cache4 ){
  ListDrives = QDir::drives();
  rCache1 = cache1;
  rCache2 = cache2;
  rCache3 = cache3;
  rCache4 = cache4;
  QStringList strl;
  strl << "batiscaff_8.png" << "batiscaff_12.png" << "batiscaff_16.png" << "batiscaff_24.png" << "batiscaff_32.png"
                           << "batiscaff_48.png"  << "batiscaff_64.png" << "batiscaff_96.png" << "batiscaff_128.png";
  foreach ( QString str, strl) {
    QPixmap *pix = new QPixmap(":/" + str);
    MainIc << pix;
  }
  readSettings();
  current = argv[0];
  current = QApplication::applicationDirPath() + "/Share/Themes/";
  none.load(":/castom/none.png");
  fullCache(theme);
  fullMapApps("/usr/share/icons");
  fullMapApps();
  fullCacheApps("/usr/share/applications");
  magic = magic_open(MAGIC_MIME_TYPE);
  magic_load(magic, 0);
  setQueueIcon();
  fullRCache();
  SaveSettings = true;

  ID_Owner = geteuid();
  ID_Group = getegid();
  fullMountPoints();
  Logo.load(":/Logo.png");
  LogoBack.load(":/Logoback.png");
}

void PixmapsCache :: fullCache(QString themes){
  QList<QString> pixlist;
  QString default_prefix, prefix;
  int interval;

  pixlist << "folder-root" << "folder-home" << "folder-usually" << "drive" << "folder-hidden" << "dragable" << "block-device" << "char-device" << "socket" << "fifo" << "list-object";
  default_prefix = "directories/";
  if ( themes == "default" ) prefix = "";
  else prefix =  current + themes + "/directories/";
  interval = 30;
  loadIconsAutomat (pixlist, default_prefix, prefix, interval);

  pixlist.clear();
  pixlist << "arrow-back" << "arrow-next" << "arrow-up" << "refresh" << "home" << "txt" << "navileft" << "naviright";
  default_prefix = "navigator/";
  if ( themes == "default" ) prefix = "";
  else prefix = current + themes + "/navigator/";
  interval = 10;
  loadIconsAutomat (pixlist, default_prefix, prefix, interval);

  pixlist.clear();
  pixlist << "icons" << "list" << "table" << "one-panel" << "two-panel" << "tree-panel" << "thumbnails" << "left-to-right" << "right-to-left" << "one-one";
  default_prefix = "control/";
  if ( themes == "default" ) prefix = "";
  else prefix = current + themes + "/control/";
  interval = 20;
  loadIconsAutomat (pixlist, default_prefix, prefix, interval);

  pixlist.clear();
  pixlist << "show-hidden" << "background-color" << "background-texture" << "font-color" << "font-size" << "icon-size" << "themes" << "is-update" << "no-update" << "clean-key" << "styles";
  default_prefix = "";
  if ( themes == "default" ) prefix = "";
  else prefix = current + themes + "/settings_bar/";
  interval = 20;
  loadIconsAutomat (pixlist, default_prefix, prefix, interval);

  pixlist.clear();
  pixlist                            <<                              "create-new"
                                        <<                              "create-symlink"
                                        <<                              "cut"
                                        <<                              "copy"
                                        <<                              "paste"
                                        <<                              "rename"
                                        <<                              "delete"
                                        <<                              "open"
                                        <<                              "open-with"
                                        <<                              "properites"
                                        <<                              "create-file"
                                        <<                              "select-all";
   default_prefix = "";
   if ( themes == "default") prefix = "";
   else prefix = current + themes + "/menus/";
   interval = 30;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "chunk-link" << "symbolic-link" << "unknown" << "standart";
   default_prefix = "castom/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/castom/";
   interval = 10;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "arrow-left" << "arrow-right" << "refresh" << "save" << "zoom-in" << "zoom-out" << "clean-history";
   default_prefix = "webtool/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/webtool/";
   interval = 20;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "previous" << "next" << "rotate-left" << "rotate-right" << "clone-horizontal" << "clone-vertical" << "negative" << "scale-viewport" << "refresh" << "error" << "warning";
   default_prefix = "imagetool/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/imagetool/";
   interval = 20;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "dont-edit" << "refresh" << "save" << "save-as" << "zoom-in" << "zoom-out" << "undo" << "redo";
   default_prefix = "texttool/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/texttool/";
   interval = 20;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "information" << "warning" << "error" << "questions" << "create-folder" << "create-file" << "create-symlink" <<"rename";
   default_prefix = "status/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/message_windows/";
   interval = 10;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

   pixlist.clear();
   pixlist << "ok" << "cancel" << "retry" << "write" << "browse" << "rename" << "save";
   default_prefix = "buttons/";
   if ( themes == "default" ) prefix = "";
   else prefix = current + themes + "/message_windows/";
   interval = 10;
   loadIconsAutomat (pixlist, default_prefix, prefix, interval);

 //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  QFileInfo fileinfo;
  QList<QFileInfo>  fileinfolist;
  QString argv;
  QDir dir;
  if ( themes == "default" ) {
     QFile iconslist(":/iconslist");
     iconslist.open(QIODevice::ReadOnly);
     QTextStream stream(&iconslist);
     QString name;
     QPixmap pixmap;
     while ( !stream.atEnd()) {
       name = stream.readLine();
       pixmap.load(":/mimes/" +  name + ".png");
       Icon[name] = pixmap;
     }
     iconslist.close();

     iconslist.setFileName(":/appslist");
     iconslist.open(QIODevice::ReadOnly);
     stream.setDevice(&iconslist);
     while ( !stream.atEnd()) {
       name = stream.readLine();
       pixmap.load(":/apps/" + name + ".png");
       Apps[name] = pixmap;
     }
     iconslist.close();
  }

  else {
    QString path;
    path = current + themes + "/mimes";
    dir.setPath (path);
    QList<QString> filelist1, filelist2;
    QList<QFileInfo>  fileinfolist;
    QString name;
    QPixmap pixmap;
    fileinfolist = dir.entryInfoList(QDir::Files);
    foreach ( QFileInfo finf, fileinfolist) {
      name = finf.completeBaseName();
      filelist2 << name;
      pixmap.load(finf.absoluteFilePath());
      Icon[name] = pixmap;
    }

    QFile iconslist(":/iconslist");
    iconslist.open(QIODevice::ReadOnly);
    QTextStream stream(&iconslist);
    while ( !stream.atEnd()) {
      name = stream.readLine();
      filelist1  << name;
    }
    iconslist.close();

    foreach ( QString str, filelist1) {
      if ( !filelist2.contains(str)) {
        pixmap.load (":/mimes/" + str + ".png");
        Icon[str] = pixmap;
      }
    }

    filelist1.clear();
    filelist2.clear();
    path = current + themes + "/apps";
    dir.setPath(path);
    fileinfolist = dir.entryInfoList(QDir::Files);
    foreach ( QFileInfo finf, fileinfolist) {
      name = finf.completeBaseName();
      filelist2 << name;
      pixmap.load(finf.absoluteFilePath());
      Apps[name] = pixmap;
    }
    iconslist.setFileName(":/appslist");
    iconslist.open(QIODevice::ReadOnly);
    stream.setDevice(&iconslist);
    while ( !stream.atEnd()) {
      name = stream.readLine();
      filelist1  << name;
    }
    iconslist.close();

    foreach ( QString str, filelist1) {
      if ( !filelist2.contains(str)) {
        pixmap.load (":/apps/" + str + ".png");
        Apps[str] = pixmap;
      }
    }
  }

  dir.setPath("/usr/share/mime");
  QFile file;
  QByteArray bytearray;
  QString locale;
  QString tmplstr (QLocale::system().name());
  QStringList lst =  tmplstr.split("_");
  locale = lst[0];

  XmlHandler handler(locale);
  QXmlInputSource source;
  QXmlSimpleReader reader;
  reader.setContentHandler(&handler);
  if ( dir.exists()) {
    QList<QString> directorylist, filelist;
    QDir tempdir;
    directorylist = dir.entryList(QDir::Dirs|QDir::NoDotAndDotDot);
    foreach ( QString str, directorylist ) {
      if ( str == "packages") continue;
      tempdir.setPath("/usr/share/mime/" + str);
      filelist = tempdir.entryList(QDir::Files);
      foreach ( QString filename, filelist) {
        file.setFileName("/usr/share/mime/" + str + "/" + filename);
        if ( !file.open(QIODevice::ReadOnly)) continue;
        bytearray = file.readAll();
        file.close();
        source.setData(bytearray);
        reader.parse(source);

        foreach ( QString alias, handler.mimetype) {
           foreach ( QString extended, handler.globs) {
              globs                        <<             extended;
              mimetype                 <<             alias;
              shortmimetype        <<             alias.split("/")[1];
              description               <<             handler.description;
              pclass                       <<             handler.pclass;
          }
        }
        handler.reset();
      }
    }
  }
  pixmap.fill(pix_list[113], mimetype.count());
  standartIcon.fill('y', mimetype.count());

                //-------------------------------------------------------------------------------------------------
                       globs                       <<          "";
                       mimetype               <<          "application/x-character-device";
                       shortmimetype      <<          "x-character-device";
                       description            <<          QObject::tr("character device");
                       pclass                    <<          "";
                       pixmap                  <<          pix_list[7];
                       standartIcon         <<          'n';
                //-------------------------------------------------------------------------------------------------
                       globs                       <<          "";
                       mimetype               <<          "application/x-block-device";
                       shortmimetype      <<          "x-block-device";
                       description            <<          QObject::tr("block device");
                       pclass                    <<          "";
                       pixmap                  <<          pix_list[6];
                       standartIcon         <<          'n';
                //-------------------------------------------------------------------------------------------------
                       globs                       <<          "";
                       mimetype               <<          "application/x-socket";
                       shortmimetype      <<          "x-soket";
                       description            <<          QObject::tr("socket");
                       pclass                    <<          "";
                       pixmap                  <<          pix_list[8];
                       standartIcon         <<          'n';
                //-------------------------------------------------------------------------------------------------
                       globs                       <<          "";
                       mimetype               <<          "application/x-fifo";
                       shortmimetype      <<          "x-fifo";
                       description            <<          QObject::tr("named pipe");
                       pclass                    <<          "";
                       pixmap                  <<          pix_list[9];
                       standartIcon         <<          'n';
                //-------------------------------------------------------------------------------------------------

  if ( themes != "default" && QFile::exists(current + themes + "/anim/running-op.gif"))
         animateStateOp = current + themes + "/anim/running-op.gif";
    else animateStateOp = ":/running-op.gif";

  theme = themes;
}

void PixmapsCache :: fullCacheApps(QString path) {
  QString lang = (QLocale::system().name()).split("_")[0];
  QPixmap *pixx = 0;
  QVector<QString>  MimeType;
  QString buffName, buffNameLocale, buffGenName, buffGenNameLocale, buffExec, buffTryExec, readstring,
                       Name, Exec;
  QDir dir(path);
  QStringList templist1, templist2, listdir;
  QRegExp regexp("%[a-z]|%[A-Z]|%[-0-9]");
  QBuffer buffer;
  QFile file;
  QByteArray bytearray;
  QTextStream stream;
  templist1 << "*.desktop";
  if (dir.exists()) {
    listdir = dir.entryList (templist1, QDir::Files);
    foreach ( QString str, listdir ) {
      MimeType.clear();
      file.setFileName(path+QDir::separator()+str);
      if ( !file.open(QIODevice::ReadOnly)) break;
      bytearray = file.readAll();
      buffer.setData(bytearray);
      file.close();
      buffer.open(QIODevice::ReadOnly);
      stream.setDevice(&buffer);
      while (!stream.atEnd()) {
        readstring = stream.readLine();
        templist1 = readstring.split("=");
        if (templist1[0] == "MimeType") {
          templist1[1].replace("\"", "");
          templist2 = templist1[1].split(";");
          foreach ( QString str, templist2) {
            if ( str != "") MimeType << str;
          }
        }
      }
      if ( MimeType.count() > 0) {
        stream.seek(0);
        while (!stream.atEnd()) {
            readstring = stream.readLine();
            templist1 = readstring.split("=");
            if (templist1[0] == "Name") buffName = templist1[1];
            if (templist1[0] == "GenericName") buffGenName = templist1[1];
            if (templist1[0] == "Exec")  {
              buffExec = templist1[1];
              buffExec.remove("\"");
              buffExec.remove(regexp);
            }
            if (templist1[0] == "TryExec") {
              buffTryExec = templist1[1];
              buffTryExec.remove("\"");
              buffTryExec.remove(regexp);
            }
            if (templist1[0] == "Icon") {
              if (Apps.contains(templist1[1])) pixx = &(Apps[templist1[1]]);
              else {
                templist2 = templist1[1].split(".");
                if (Apps.contains(templist2[0])) pixx = &(Apps[templist2[0]]);
                else pixx = pix_list[113];
              }
            }
         }
      }
      buffer.close();

      if ( buffName.isEmpty()) Name = buffGenName; else Name = buffName;
      if ( buffTryExec.isEmpty()) Exec = buffTryExec; else Exec = buffExec;
      if ( Name.isEmpty() || Exec.isEmpty()) continue;
      foreach ( QString str, MimeType) {
        nameApp << Name;
        iconApp << pixx;
        mimeApp << str;
        execApp << Exec;
      }
    }
    listdir = dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot | QDir::NoSymLinks);
    foreach ( QString str, listdir) {
      fullCacheApps(path+QDir::separator()+str);
    }
  }
}

void PixmapsCache :: fullMapApps(QString path) {
  QDir dir(path);
  QPixmap pixmap;
  if ( dir.exists()) {
    QList<QFileInfo> listfile;
    QStringList extend;
    extend << "*.png" << "*xpm";
    QStringList list = dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot | QDir::NoSymLinks);
    foreach ( QString str, list) {
      dir.setPath(path+QDir::separator() + str + "/32x32/apps");
      if ( dir.exists()) {
        listfile = dir.entryInfoList(extend, QDir::Files | QDir::NoSymLinks);
        foreach( QFileInfo fileinfo, listfile) {
          if ( !Apps.contains(fileinfo.completeBaseName())) {
            pixmap.load(fileinfo.absoluteFilePath());
            Apps[fileinfo.completeBaseName()] = pixmap;
          }
        }
      }
    }

    dir.setPath(path);
    listfile.clear();
    list = dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot | QDir::NoSymLinks);
    foreach ( QString str, list) {
      dir.setPath(path+QDir::separator() + str + "/128x128/mimetypes");
      if ( dir.exists()) {
        listfile = dir.entryInfoList(extend, QDir::Files | QDir::NoSymLinks);
        foreach( QFileInfo fileinfo, listfile) {
          if ( !Icon.contains(fileinfo.completeBaseName())) {
            pixmap.load(fileinfo.absoluteFilePath());
            Icon[fileinfo.completeBaseName()] = pixmap;
          }
        }
      }
    }
  }
}

void PixmapsCache :: fullMapApps() {
  QDir dir("/usr/share/pixmaps");
  if ( dir.exists()) {
    QList<QFileInfo> listfile;
    QStringList extend;
    extend << "*.png" << "*xpm";
    listfile = dir.entryInfoList(extend, QDir::Files | QDir::NoSymLinks);
    foreach( QFileInfo fileinfo, listfile) {
      if ( !Apps.contains(fileinfo.completeBaseName())) {
        QPixmap pixmap(fileinfo.absoluteFilePath());
        Apps[fileinfo.completeBaseName()] = pixmap;
      }
    }
  }
}

void PixmapsCache :: setQueueIcon() {
  QString mime, mime2;
  QStringList lstmime;
  for ( int i = 0; i < mimetype.count(); ++i) {

    if ( standartIcon[i] == 'y') {
       mime = mimetype[i];
       mime2 = mime;
       mime2.replace("/", "-");
       if ( Icon.contains(mime2)) {
         pixmap[i] = &(Icon[mime2]);
         standartIcon[i] = 'n';
         continue;
       }
       lstmime = mime.split("/");
       if ( Icon.contains(lstmime[0] + "-x-generic")) {
         pixmap[i] = &(Icon[lstmime[0] + "-x-generic"]);
         standartIcon[i] = 'n';
         continue;
       }
    }
  }

  for ( int i = 0; i < mimetype.count(); ++i) {
    QString parentclass;
    int n;
    if ( standartIcon[i] == 'y') {
      parentclass = pclass[i];
      n = i;
      if ( !parentclass.isEmpty()) {
         while (true) {
           n = mimetype.indexOf(parentclass);
           if ( n == -1 ) break;
           if ( standartIcon[n] == 'n') {
             pixmap[i] = pixmap[n];
             standartIcon[i] = 'n';
             break;
           }
           parentclass = pclass[n];
           if ( parentclass.isEmpty()) break;
         }
      }
    }
  }

  QString smime;
  for ( int i = 0; i < mimetype.count(); ++i ) {
    if ( standartIcon[i] == 'y') {
      smime = shortmimetype[i];
      for (int n = 0; n < mimetype.count(); ++n) {
        if ( n != i )
           if ( shortmimetype[i] == shortmimetype[n])
             if (standartIcon[n] == 'n') {
                pixmap[i] = pixmap[n];
                standartIcon[i] = 'n';
             }
      }
    }
  }
}

void PixmapsCache :: fullRCache() {
  for ( int i = 0; i < mimetype.count(); ++i) {
    rCache1->mimetype << mimetype.value(i);
    rCache1->shortmimetype << shortmimetype.value(i);
    rCache1->globs << globs.value(i);
    rCache1->description << description.value(i);
    rCache1->pclass << pclass.value(i);

    rCache2->mimetype << mimetype.value(i);
    rCache2->shortmimetype << shortmimetype.value(i);
    rCache2->globs << globs.value(i);
    rCache2->description << description.value(i);
    rCache2->pclass << pclass.value(i);

    rCache3->mimetype << mimetype.value(i);
    rCache3->shortmimetype << shortmimetype.value(i);
    rCache3->globs << globs.value(i);
    rCache3->description << description.value(i);
    rCache3->pclass << pclass.value(i);

    rCache4->mimetype << mimetype.value(i);
    rCache4->shortmimetype << shortmimetype.value(i);
    rCache4->globs << globs.value(i);
    rCache4->description << description.value(i);
    rCache4->pclass << pclass.value(i);
  }
}

QList<TemplateApps> PixmapsCache :: fullTemplateApps (QFileInfo fileinfo) {
  QByteArray buf;
  QList<TemplateApps> Tapps;
  TemplateApps tapps;
  QFileInfo TargetInfo;
  if ( fileinfo.isSymLink()) {
    TargetInfo.setFile(fileinfo.symLinkTarget());
    while (TargetInfo.isSymLink()) TargetInfo.setFile(TargetInfo.symLinkTarget());
    if ( TargetInfo.exists()) fileinfo = TargetInfo;
  }
  buf = fileinfo.absoluteFilePath().toLocal8Bit();
  QString ext, mime2;
  int i;
  ext = fileinfo.suffix().toLower();
  if (ext == "") i =-1; else i = globs.indexOf(ext);
  if ( i != -1 ) mime2 = mimetype[i];
  if ( i == -1) {
    ext = fileinfo.completeSuffix().toLower();
    if (ext == "") i = -1; else i = globs.indexOf(ext);
    if ( i != -1 ) mime2 = mimetype[i];
    if ( i == -1 ) {
      QString mime(magic_file(magic, buf));
      i = mimeApp.indexOf(mime);
      if ( i != -1 ) mime2 = mime;
      if ( i == -1) {
        QStringList mimes = mime.split("/");
        if (mimes.count() >= 2) mime2 = mimes[1]; else mime2 = mimes[0];
        i = shortmimetype.indexOf(mime2);
        if ( i == -1 ) return Tapps;
        else mime2 = mimetype[i];
      }
    }
  }

  if ( !mime2.isEmpty()) {
    i = 0;
    bool fl;
    foreach ( QString str, mimeApp ) {
      if ( str == mime2 ) {
        fl = true;
        foreach ( TemplateApps ttapps, Tapps ) {
          if ( ttapps.nameApp == nameApp[i] ) { fl = false; break; }
        }
        if ( fl ) {
          tapps.nameApp = nameApp[i];
          tapps.iconApp = iconApp[i];
          tapps.execApp = execApp[i];
          Tapps << tapps;
        }
      }
      ++i;
    }

    QList<int> tempindex;
    i = mimetype.indexOf(mime2);
    while ( i != -1 ) {
      ext = pclass[i];
      if ( ext == "" ) break;
      i = mimetype.indexOf(ext);
      if ( i != -1 )  tempindex << i;
    }
    foreach ( int n, tempindex) {
      mime2 = mimetype[n];
      i = 0;
      foreach ( QString str, mimeApp ) {
        if ( str == mime2 ) {
          fl = true;
          foreach ( TemplateApps ttapps, Tapps ) {
            if ( ttapps.nameApp == nameApp[i] ) { fl = false; break; }
          }
          if ( fl ) {
            tapps.nameApp = nameApp[i];
            tapps.iconApp = iconApp[i];
            tapps.execApp = execApp[i];
            Tapps << tapps;
          }
        }
        ++i;
      }
    }
  }

  return Tapps;
}

void PixmapsCache :: loadIconsAutomat ( QList<QString> filename, QString default_prefix, QString prefix, int count ) {
  int n = filename.count();
  QString str;
  QPixmap *pix;

  if ( prefix != "" ) {
      for ( int i = 0; i < count; ++i ) {
        if ( i < n ) {
          str = prefix + filename[i] + ".png";
          if ( QFile::exists(str)) {
            pix = new QPixmap(str);
          }
          else {
            pix = new QPixmap(":/" + default_prefix + filename[i] + ".png");
          }
          pix_list << pix;
        }
        else {
          pix_list << &none;
        }
      }
  }
  else {
      for ( int i = 0; i < count; ++i ) {
        if ( i < n ) {
          pix = new QPixmap(":/" + default_prefix + filename[i] + ".png");
          pix_list << pix;
        }
        else {
          pix_list << &none;
        }
      }
  }
}

                                                                    /******************************************************************************************************
                                                                    **      Note:          Во всех функциях c аргументом QFileInfo (fileinfo) подразумевается, что
                                                                    **                          он является файлом, и что он существует.
                                                                    **      Example:
                                                                               QFileInfo TargetInfo;
                                                                               QString Target;
                                                                               if ( fileinfo.isSymLink()) {
                                                                                 Target = fileInfo.symLinkTarget();
                                                                                 TargetInfo.setFile(Target);
                                                                                 while (TargetInfo.isSymLink()) TargetInfo.setFile(TargetInfo.symLinkTarget());
                                                                                 if ( TargetInfo.exists()) {
                                                                                   if ( TargetInfo.isDir()) {
                                                                                       ---------  This is Directory
                                                                                     }
                                                                                     if ( TargetInfo.isFile()) {
                                                                                       ---------  This is File
                                                                                                    Можно вызвать:
                                                                                                    getIcon (fileinfo);
                                                                                                    getIcon(fileinfo, QString*);
                                                                                                    getIcon(fileinfo, QString*, QString*);
                                                                                                    и т. д.
                                                                                     }
                                                                                   }
                                                                                  else { Битая ссылка }

                                                                                 Target   -   указывает на целевой файл
                                                                    **********************************************************************************************************/

QPixmap* PixmapsCache :: getIcon(QFileInfo fileinfo) {
  QString desc;
  return getIcon(fileinfo, &desc);
}

QPixmap * PixmapsCache :: getIcon(QFileInfo fileinfo, QString *descr) {
  int n;
  QString suffix = fileinfo.suffix().toLower();
  if ( !suffix.isEmpty()) {
    n = globs.indexOf(suffix);
    if ( n != -1) {
      *descr = description[n];
      return pixmap[n];
    }
  }
  QByteArray buf = fileinfo.absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  n = mimetype.indexOf(mim);
  if ( n != -1) {
    *descr = description[n];
    return pixmap[n];
  }
  else {
    QStringList lst = mim.split("/");
    if ( lst.count() > 1) {
      mim = lst[1];
      n = shortmimetype.indexOf(mim);
      if ( n != -1) {
        *descr = description[n];
        return pixmap[n];
      }
    }
  }
  if ( fileinfo.size() == 0 ) {
    *descr = QObject::tr("empty document");
    return pix_list[113];
  }
  *descr = QObject::tr("unknown");
  return pix_list[112];
}

QPixmap * PixmapsCache :: getIcon(QFileInfo fileinfo, QString *descr, QString *mimm) {
  int n;
  QString suffix = fileinfo.suffix().toLower();
  if ( !suffix.isEmpty()) {
    n = globs.indexOf(suffix);
    if ( n != -1) {
      *mimm = mimetype[n];
      *descr = description[n];
      return pixmap[n];
    }
  }
  QByteArray buf = fileinfo.absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  *mimm = mim;
  n = mimetype.indexOf(mim);
  if ( n != -1) {
    *descr = description[n];
    return pixmap[n];
  }
  else {
    QStringList lst = mim.split("/");
    if ( lst.count() > 1) {
      mim = lst[1];
      n = shortmimetype.indexOf(mim);
      if ( n != -1) {
        *descr = description[n];
        return pixmap[n];
      }
    }
  }
  if ( fileinfo.size() == 0 ) {
    *descr = QObject::tr("empty document");
    return pix_list[113];
  }
  *descr = QObject::tr("unknown");
  return pix_list[112];
}


void PixmapsCache :: getIndexIcon( QFileInfo *fileinfo, QString *descr, int *index, int* flag ) {
  int n;
  QString suffix = fileinfo->suffix().toLower();
  if ( !suffix.isEmpty()) {
    n = globs.indexOf(suffix);
    if ( n != -1) {
      *index = n;
      *flag = 1;
      *descr = description[n];
      return;
    }
  }
  QByteArray buf = fileinfo->absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  n = mimetype.indexOf(mim);
  if ( n != -1) {
    *index = n;
    *flag = 1;
    *descr = description[n];
    return;
  }
  else {
    QStringList lst = mim.split("/");
    if ( lst.count() > 1) {
      mim = lst[1];
      n = shortmimetype.indexOf(mim);
      if ( n != -1) {
        *index = n;
        *flag = 1;
        *descr = description[n];
        return;
      }
    }
  }
  if ( fileinfo->size() == 0 ) {
    *flag = 0;
    *index = 113;
    *descr = QObject::tr("empty document");
    return;
  }
  *flag = 0;
  *index = 112;
  *descr = QObject::tr("unknown");
  return;
}


Template PixmapsCache :: fullTemplate(QFileInfo source) {
  Template Templ;
  QFileInfo target;
  Templ.FullName = source.absoluteFilePath();
  Templ.BaseName = source.completeBaseName();
  Templ.FileName = source.fileName();
  Templ.Path = source.absolutePath();
  QDir dir;
  QString starg;
  if ( source.isSymLink()) {
    Templ.Mime = "inode/symlink";
    target.setFile(source.symLinkTarget());
    if ( target.isSymLink()) starg = " (" + QObject::tr("to link") + ")";
    else if ( target.isDir()) starg = " (" + QObject::tr("to directory") + ")";
               else starg = " (" + QObject::tr("to file") + ")";
    Templ.SymLink = true;
    int z;
    Templ.TargetLink = readSymLink(source.absoluteFilePath(), &z);
    while  ( target.isSymLink()) target.setFile(target.symLinkTarget());
    if ( target.exists()) {
        if ( target.isDir()) {
          Templ.Type = QObject::tr("symbolic link") + starg;
          Templ.DescrFromContents = "";
          Templ.Icon = *(getIcon(2));
          dir.setPath(Templ.TargetLink);
          Templ.Size = QString::number(countDir(target.absoluteFilePath())) + " " + QObject::tr("element(s)");
          if ( target.absoluteFilePath() == QDir::homePath()) Templ.Icon = *(getIcon(1));
          if ( ListDrives.contains(target)) Templ.Icon = *(getIcon(3));
          if ( target.isRoot()) Templ.Icon = *(getIcon(0));
          if ( target.isHidden()) Templ.Icon = *(getIcon(4));
        }
        else {
          Templ.Type = QObject::tr("symbolic link") + starg;
          unsigned long size = target.size();
          int i;
          QList<QString> label;
          label << QObject::tr("byte(s)") << QObject::tr("Kb") << QObject::tr("Mb") << QObject::tr("Gb") << QObject::tr("Tb");
          for (  i = 0; i < 5; i++ ) {
            if ( size < 1000 ) break;
            size = size / 1000;
          }
          Templ.Size = QString::number(size) + " " + label[i];
          Templ.Icon = *(getIcon(target, &Templ.Descr, &Templ.Mime));
          Templ.DescrFromContents = getDescrFromContents(target);
        }
    }
    else {
      Templ.Icon = *(getIcon(113));
      Templ.Type = QObject::tr("broken link");
      Templ.Size = QString::number(source.size()) + " " + QObject::tr("bytes");
      Templ.DescrFromContents = QObject::tr("unknown");
      Templ.Descr = QObject::tr("unknown");
    }
    QPainter painter;
    painter.begin(&Templ.Icon);
    painter.drawPixmap(0, 64, getIcon(111)->scaled(64, 64, Qt::KeepAspectRatio));
    painter.end();
  }
  else {
    Templ.SymLink = false;
    if ( source.isDir()) {
          Templ.Type = QObject::tr("catalog");
          Templ.Mime = "inode/directory";
          dir.setPath(source.absoluteFilePath());
          Templ.DescrFromContents = "";
          Templ.Size = QString::number(countDir(source.absoluteFilePath())) + " " + QObject::tr("element(s)");
          Templ.Icon = *(getIcon(2));
          if ( source.absoluteFilePath() == QDir::homePath()) { Templ.Icon = *(getIcon(1)); Templ.Type = QObject::tr("Home catalog"); }
          if ( ListDrives.contains(source)) { Templ.Icon = *(getIcon(3)); Templ.Type = QObject::tr("Drive"); }
          if ( source.isRoot()) { Templ.Icon = *(getIcon(0)); Templ.Type = QObject::tr("Root catalog"); }
          if ( source.isHidden()) { Templ.Icon = *(getIcon(4)); Templ.Type = QObject::tr("catalog (hidden)"); }
        }
        else {
            qint64 size = source.size();
            int i;
            QList<QString> label;
            label << QObject::tr("byte(s)") << QObject::tr("Kb") << QObject::tr("Mb") << QObject::tr("Gb") << QObject::tr("Tb");
            for (  i = 0; i < 5; i++ ) {
              if ( size < 1000 ) break;
              size = size / 1000;
            }
            Templ.Type = QObject::tr("file");
            Templ.Size = QString::number(size) + " " + label[i];
            Templ.Icon = *(getIcon(source, &Templ.Descr, &Templ.Mime));
            Templ.DescrFromContents = getDescrFromContents(source);
        }
  }

   if ( source.isSymLink() && !source.exists()) {
     struct stat sb;
     if (lstat(source.absoluteFilePath().toLocal8Bit(), &sb) == -1) {
       Templ.Created = QObject::tr("unknown");
       Templ.LastModified = QObject::tr("unknown");
       Templ.LastRead = QObject::tr("unknown");
       Templ.Size = QObject::tr("0 byte");
     }
     else {
       Templ.Created = QDateTime::fromTime_t(sb.st_ctime).toString("dd.MM.yy hh:mm");
       Templ.LastModified = QDateTime::fromTime_t(sb.st_mtime).toString("dd.MM.yy hh:mm");
       Templ.LastRead = QDateTime::fromTime_t(sb.st_atime).toString("dd.MM.yy hh:mm");
       Templ.Size = QString::number(sb.st_size) + " " + QObject::tr("byte");
     }
   }
   else {
    Templ.Created = source.created().toString("dd.MM.yy hh:mm");
    Templ.LastModified = source.lastModified().toString("dd.MM.yy hh:mm");
    Templ.LastRead = source.lastRead().toString("dd.MM.yy hh:mm");
   }
   return Templ;
}

void PixmapsCache :: readSettings() {
  QSettings settings;
  settings.beginGroup("/Bathyscaphe/PixmapsCache");
  theme = settings.value ( "/Theme", "default").toString();

  QByteArray arr;
  arr = settings.value("/UserApplicationList", QByteArray()).toByteArray();
  QDataStream stream(arr);
  stream >> UserApplicationList;
  arr = settings.value("/AssociationList", QByteArray()).toByteArray();
  QDataStream streami(arr);
  streami >> AssociationList;

  settings.endGroup();
}

void PixmapsCache :: writeSettings() {
  if ( SaveSettings ) {
    QSettings settings;
    settings.beginGroup("/Bathyscaphe/PixmapsCache");
    settings.setValue("/Theme", theme);

    QByteArray arr;
    QDataStream stream(&arr, QIODevice::WriteOnly);
    stream << UserApplicationList;
    settings.setValue("/UserApplicationList", arr);
    QByteArray arri;
    QDataStream streami(&arri, QIODevice::WriteOnly);
    streami << AssociationList;
    settings.setValue("/AssociationList", arri);

    settings.endGroup();
  }
}

QString PixmapsCache :: returnExec(QString string) {
  int i = 0;
  foreach ( QString str, nameApp) {
    if ( str == string ) return execApp[i];
    ++i;
  }
  return "";
}


QString PixmapsCache :: getDescrFromContents(QFileInfo fileinfo) {
  QByteArray buf = fileinfo.absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  QString mimm = mim;
  int n = mimetype.indexOf(mim);
  if ( n != -1) {
    return description[n];
  }
  else {
    QStringList lst = mim.split("/");
    if ( lst.count() > 1) {
      mim = lst[1];
      n = shortmimetype.indexOf(mim);
      if ( n != -1) {
        return description[n];
      }
    }
  }
  return QObject::tr("unknown");
}


QString PixmapsCache :: getMimeSource(QFileInfo fileinfo) {
  QString mimm;
   int n;
  QString suffix = fileinfo.suffix().toLower();
  if ( !suffix.isEmpty()) {
    n = globs.indexOf(suffix);
    if ( n != -1) return mimetype[n];
  }
  QByteArray buf = fileinfo.absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  mimm = mim;
  if ( mimetype.indexOf(mim) != -1) return mim;
  else {
    QStringList lst = mim.split("/");
    if (lst.count() > 1) mim = lst[1]; else return mimm;
    int i = shortmimetype.indexOf(mim);
    if ( i != -1) return mimetype[i]; else return mimm;
  }
}


bool PixmapsCache :: subClassMime( QString str, QString templ) {
   int i;
   i = mimetype.indexOf(str);
   if ( i != -1) {
     if ( mimetype[i] == templ ) return true;
     QString parentclass = pclass[i];
     if ( parentclass == templ ) return true;
     while ( parentclass != "" ) {
       i = mimetype.indexOf(parentclass);
       if ( i == -1) break;
       parentclass = pclass[i];
       if ( parentclass == templ ) return true;
     }
   }
   return false;
}

QVector<TemplateApps> PixmapsCache :: getApplicationList() {
  QVector <TemplateApps> Tapps;
  TemplateApps tapps;
  int i = 0;
  QString oldstr;
  foreach ( QString str, nameApp) {
    if ( oldstr != str ) {
      oldstr = str;
      tapps.nameApp = str;
      tapps.iconApp =  iconApp[i];
      tapps.execApp = execApp[i];
      Tapps << tapps;
      ++i;
    }
    else ++i;
  }
  return Tapps;
}

void PixmapsCache :: addUserApplicationItem (QString str ) {
  if ( UserApplicationList.contains(str)) {
    UserApplicationList.removeOne(str);
  }
  UserApplicationList << str;
  if ( UserApplicationList.count() >= 20) UserApplicationList.pop_front();
}

void PixmapsCache :: addAssociationItem (QString mimename, QString programname, bool add) {
  if ( add ) AssociationList[mimename] = programname;
  else {
    if ( AssociationList.contains(mimename)) {
      AssociationList.remove(mimename);
    }
  }
}

bool PixmapsCache :: findAssociation (QString mimename, QString programname) {
  if ( AssociationList.contains(mimename))
    if ( AssociationList[mimename] == programname){
      return true;
    }

  return false;
}

QString PixmapsCache :: findAssociation ( QString mimename) {
  if ( AssociationList.contains(mimename)) return AssociationList[mimename];
  else return "";
}

QList<QString> PixmapsCache :: fullMountPoints() {
  MountPoints.clear();
  QFile file("/etc/mtab");
  if (!file.open(QIODevice::ReadOnly)) return MountPoints;
  char buf[1024];
  while(!file.atEnd()) {
    file.readLine(buf, sizeof(buf));
    QString strr(QString::fromUtf8(buf));
    QStringList liststrr = strr.split(" ");
    if ( liststrr.count() >= 2 ) {
      if ( liststrr[0].startsWith("/dev/")) MountPoints << liststrr[1];
    }
  }
  file.close();
  return MountPoints;
}

QList<QString> PixmapsCache :: getMountPoints() {
  return MountPoints;
}

QString PixmapsCache :: locateMountPoints(QString path) {
  QList<QString> tmpList;
  foreach ( QString strr, MountPoints) {
    if ( path.contains(strr)) tmpList << strr;
  }
  if ( tmpList.count() == 0) return "";
    else return tmpList.last();
}

PixmapsCache :: ~PixmapsCache () {
  writeSettings();
  magic_close(magic);
}
