#include "../../Include/ReserveCache.h"

ReserveCache :: ReserveCache() {
  magic = magic_open(MAGIC_MIME_TYPE);
  magic_load(magic, 0);
  }

void ReserveCache :: getIndexIcon( QFileInfo *fileinfo, QString *descr, int* index, int* flag ) {
  int n;
  QString suffix = fileinfo->suffix().toLower();
  if ( !suffix.isEmpty()) {
    n = globs.indexOf(suffix);
    if ( n != -1) {
      *index = n;
      *flag = 1;
      *descr = description[n];
      return;
    }
  }

  QByteArray buf = fileinfo->absoluteFilePath().toLocal8Bit();
  QString mim(magic_file(magic, buf));
  n = mimetype.indexOf(mim);
  if ( n != -1) {
    *index = n;
    *flag = 1;
    *descr = description[n];
    return;
  }
  else {
    QStringList lst = mim.split("/");
    if ( lst.count() > 1) {
      mim = lst[1];
      n = shortmimetype.indexOf(mim);
      if ( n != -1) {
        *index = n;
        *flag = 1;
        *descr = description[n];
        return;
      }
    }
  }
  if ( fileinfo->size() == 0 ) {
    *flag = 0;
    *index = 113;
    *descr  = QObject::tr("empty document");
    return;
  }
  *flag = 0;
  *index = 112;
  *descr = QObject::tr("unknown");
  return;
}
