#include "../../Include/PixmapsCache.h"

XmlHandler :: XmlHandler (QString language) : QXmlDefaultHandler() {
  lang = language;

  lang_description = "";
  default_description = "";
  buffer = "";
  attribute = "";

  description = "";
  nameicon = "";
  pclass = "";
}

bool XmlHandler :: startElement(const QString&, const QString&, const QString& tagName, const QXmlAttributes& attrs) {
  if ( tagName == "mime-type" ) {
    for ( int i = 0; i < attrs.count(); ++i ) {
      if ( attrs.localName(i) == "type" )  mimetype << attrs.value(i);
    }
  }
  else {
    if ( attrs.count() >= 1 ) attribute = attrs.value(0);
    else attribute = "";
  }
  return true;
}

bool XmlHandler :: characters(const QString& string) {
  buffer = string;
  return true;
}

bool XmlHandler :: endElement( const QString&, const QString&, const QString & tagName) {
  if ( tagName == "comment" ) {
    if ( attribute == "" || attribute == "en" ) default_description = buffer;
    if ( attribute == lang ) lang_description = buffer;
  }
  if ( tagName == "generic-icon" )  nameicon = attribute;
  if ( tagName == "glob" ) {
    attribute.replace("*.", "");
    globs << attribute;

  }
  if ( tagName == "sub-class-of" ) pclass = attribute;
  if ( tagName == "alias" ) mimetype << attribute;
  return true;
}

bool XmlHandler :: endDocument () {
  if ( lang_description == "" ) description = default_description;
  else description = lang_description;

  if (globs.count() == 0) globs << "";

  lang_description = "";
  default_description = "";
  buffer = "";
  attribute = "";
  return true;
}

bool XmlHandler :: fatalError ( const QXmlParseException&) {
  return false;
}

void XmlHandler :: reset() {
  description = "";
  nameicon = "";
  mimetype.clear();
  pclass = "";
  globs.clear();
}
