#include "../../Include/TextViewerTool.h"

CTextViewerTool :: CTextViewerTool ( PixmapsCache * pxcache, QWidget * wgt) : CToolBar (wgt ) {
  pxCache = pxcache;
  int width = (iconSize().width() + 8) * 2;

  DontEditButton = addAction ( *(pxCache->getIcon(160)), tr("Don't edit"), tr("Don't edit"));
  DontEditButton->setCheckable(true);
  addSeparator();
  UndoButton = addAction(*(pxCache->getIcon(166)), tr("Undo"));
  UndoButton->setMaximumWidth(width);
  UndoButton->setMinimumWidth(width);
  RedoButton = addAction(*(pxCache->getIcon(167)), tr("Redo"));
  RedoButton->setMaximumWidth(width);
  RedoButton->setMinimumWidth(width);
  RefreshButton = addAction(*(pxCache->getIcon(161)), tr("Refresh"));
  RefreshButton->setMaximumWidth(width);
  RefreshButton->setMinimumWidth(width);
  Layout.addStretch(1);
  StateLabel = new QLabel();
  Layout.addWidget(StateLabel);
  addSeparator();
  SaveButton = addAction(*(pxCache->getIcon(162)), tr("Save"), tr("Save file"));
  SaveAsButton = addAction(*(pxCache->getIcon(163)), tr("Save as..."), tr("Save file with new name"));
  addSeparator();
  ScaleButtonPlus = addAction(*(pxCache->getIcon(164)), tr("Scale up"));
  ScaleText = new QLabel();
  ScaleText->setMaximumHeight(iconSize().height() + 14);
  ScaleText->setMinimumHeight(iconSize().height() +14);
  ScaleText->setMaximumWidth(iconSize().width() * 3);
  ScaleText->setMinimumWidth(iconSize().width() * 3);
  ScaleText->setAlignment(Qt::AlignCenter);
  Layout.addWidget(ScaleText);
  ScaleButtonMinus = addAction(*(pxCache->getIcon(165)), tr("Scale down"));
}

void CTextViewerTool :: refreshTheme() {
  DontEditButton->setIcon(*(pxCache->getIcon(160)));
  UndoButton->setIcon(*(pxCache->getIcon(166)));
  RedoButton->setIcon(*(pxCache->getIcon(167)));
  RefreshButton->setIcon(*(pxCache->getIcon(161)));
  SaveButton->setIcon(*(pxCache->getIcon(162)));
  SaveAsButton->setIcon(*(pxCache->getIcon(163)));
  ScaleButtonPlus->setIcon(*(pxCache->getIcon(164)));
  ScaleButtonMinus->setIcon(*(pxCache->getIcon(165)));
}

void CTextViewerTool :: setFontSize() {
  CToolBar::setFontSize();
  QFont font;
  font = *(this->font());
  font.setBold(true);
  StateLabel->setFont(font);
  ScaleText->setFont(font);
  int width = (iconSize().width() + 8) * 2;
  UndoButton->setMaximumWidth(width);
  UndoButton->setMinimumWidth(width);
  RedoButton->setMaximumWidth(width);
  RedoButton->setMinimumWidth(width);
  RefreshButton->setMinimumWidth(width);
  RefreshButton->setMaximumWidth(width);
}














