#include "../../Include/ThreadOp.h"


CProgressW :: CProgressW (QList<QString> sour, QString targ, int tp, QObject* parent) : CThreadOp(sour, targ, tp, parent) {
  wtimer = new QTimer(this);
  threadGS = new CThreadGS(sour, &sizeData, &countData);
  trueW = false;
  endcount = false;

  connect ( wtimer, SIGNAL(timeout()), SLOT(createProgressW()));
  connect ( threadGS, SIGNAL(signalOfValueSizeAndCount(quint64, quint64)),
                                       SLOT(setOfValueSizeAndCount(quint64, quint64)));
  connect (this, SIGNAL(complete()), SLOT(getComplete()));

}

void CProgressW :: setOfValueSizeAndCount ( quint64 size, quint64 count) {
  sizeData = size;
  countData = count;
  endcount = true;

  QList<QString> lbl;
  lbl << tr("byte(s)") << tr("Kb") << tr("Mb") << tr("Gb") << tr("Tb");
  quint64 fsize = sizeData, i = 0;
  if ( endcount ) {
     for ( i = 0; i < 5; ++i ) {
        if ( fsize < 1000 ) break;
        fsize = fsize/1000;
      }
  }
  sizestring = tr("All") + ":   " + QString::number(fsize) +" " + lbl[i] + "  /  " + QString::number(countData) + " " + tr("element(s)");
}

void CProgressW :: createProgressW() {
  if (trueW) {
    wtimer->stop();
    return;
  }
  wtimer->stop();
  frame = new QGroupBox();
  frame->setContentsMargins(0,0,0,0);
  frame->setAutoFillBackground(true);

  labelHeader = new QLabel();
  countElement = new QLabel();
  detals = new QLabel();

  progressBar = new QProgressBar();
  progressBar->setRange(0, 100);
  progressBar->setAlignment(Qt::AlignCenter);

  buttonLayout = new QHBoxLayout();
  cancelButton = new QPushButton();
  cancelButton->setText(tr("Cancel"));

  layout = new QVBoxLayout();
  layout->setMargin(0);
  layout->addWidget(labelHeader);
  layout->addWidget(countElement);
  layout->addWidget(detals);
  layout->addWidget(progressBar);
  buttonLayout->addStretch(1);
  buttonLayout->addWidget(cancelButton);
  layout->addLayout(buttonLayout);

  frame->setLayout(layout);
  QFileInfo finf(source[0]);
  detals->setText(tr("Source:") + " " + finf.absolutePath() + "\n" + tr("Target:") + " " + target);

  if ( type == 1 ) labelHeader->setText("<h3>" + tr("Running operation: coping") + " ...</h3>");
  if ( type == 2 ) labelHeader->setText("<h3>" + tr("Running operation: moving") + " ...</h3>");
  if ( type == 3 ) {
    labelHeader->setText("<h3>" + tr("Running operation: deleting") + " ...</h3>");
    detals->setText(tr("Source:") + " " + finf.absolutePath() + "\n" + tr("Target:") + " " + "NULL");
  }
  if ( type == 4 ) labelHeader->setText("<h3>" + tr("Running operation: creating symlink") + " ...</h3>");

  trueW = true;
  connect ( this, SIGNAL(execComplete(int)), SLOT(setRange(int)));
  connect ( cancelButton, SIGNAL(clicked()), SLOT(emitAbortOperationClicked()));
  emit showProgressW(this);
}


void CProgressW :: setRange(int value) {
  if ( !endcount )   countElement->setText(QString::number(sizeData) + " " + tr("byte(s)") + "  /  " + QString::number(countData) + " " + tr("elements  (counting...)"));
  else countElement->setText(sizestring);
  progressBar->setValue(value);
}

void CProgressW :: getComplete() {
  threadGS->trueExit();
  while ( threadGS->isRunning())  { threadGS->trueExit(); QApplication::processEvents(); }
  delete threadGS;

  CThreadOp::quit();
  CThreadOp::wait();

  emit endExec(this);
}

void CProgressW :: emitAbortOperationClicked() {
  errprint = false;
  bitState->setBit(10, true);
}


