#include "../../Include/StatusBar.h"

CTryEvent :: CTryEvent(QObject *obj) : QObject(obj) { }

bool CTryEvent :: eventFilter(QObject*, QEvent *ev) {
  if ( ev->type() == QEvent::Close) {
    emit closeWnd();
    return true;
  }
  return false;
}

CStatusBar :: CStatusBar(PixmapsCache* cache, QWidget *wgt) : QWidget(wgt) {
   pxCache = cache;
   readSettings();
   setAutoFillBackground(true);
   setContentsMargins(0, 0, 0, 0);
   listdrives = QDir::drives();
   labelIcon = new QLabel();
   labelIcon->setMinimumWidth(120);
   labelIcon->setAlignment (Qt::AlignCenter);
   labelName = new QLabel();
   labelType = new QLabel();
   labelMimeType = new QLabel();
   labelDescription = new QLabel();
   labelTarget = new QLabel();
   labelModified = new QLabel();
   labelSize = new QLabel();
   labelNameH = new QLabel("<b>" + tr("Name:") + "</b>");
   labelTypeH = new QLabel("<b>" + tr("Type:") + "</b>");
   labelMimeTypeH = new QLabel("<b>MIME:</b>");
   labelDescriptionH = new QLabel("<b>" + tr("Description:") + "</b>");
   labelTargetH = new QLabel("<b>" + tr("Target on:") + "</b>");
   labelModifiedH = new QLabel("<b>" + tr("Modified:") + "</b>");
   labelSizeH = new QLabel("<b>" + tr("Size:") + "</b>");
   labelAbcFilterHRight = new QLabel("<b>" + tr("Quick") + "<b>");
   labelMimeFilterHRight = new QLabel("<b>Mime</b>");
   labelTemplateFilterHRight = new QLabel("<b>" + tr("Mask") + "</b>");
   labelAbcFilterHLeft = new QLabel("<b>" + tr("Quick") + "<b>");
   labelMimeFilterHLeft = new QLabel("<b>Mime</b>");
   labelTemplateFilterHLeft = new QLabel("<b>" + tr("Mask") + "</b>");
   abcFilterRight = new QLineEdit();
   abcFilterRight->setReadOnly(true);
   templateFilterRight = new QPushButton();
   mimeFilterRight = new QPushButton();
   abcFilterLeft = new QLineEdit();
   abcFilterLeft->setReadOnly(true);
   templateFilterLeft = new QPushButton();
   mimeFilterLeft= new QPushButton();


   layoutDescription = new QGridLayout();
   layoutDescription->setMargin(0);
   layoutFilterRight = new QGridLayout();
   layoutFilterRight->setMargin(0);
   layoutFilterLeft = new QGridLayout();
   layoutFilterLeft->setMargin(0);
   mainLayout = new QHBoxLayout();
   mainLayout->setMargin(0);
   shellLayout = new QHBoxLayout(this);
   shellLayout->setMargin(0);

   layoutDescription->addWidget(labelNameH,          0, 0);
   layoutDescription->addWidget(labelName,              0, 1, 1, 3);
   layoutDescription->addWidget(labelTypeH,             1, 0);
   layoutDescription->addWidget(labelType,                1, 1, 1, 1);
   layoutDescription->addWidget(labelModifiedH,         2, 0);
   layoutDescription->addWidget(labelModified,            2, 1);
   layoutDescription->addWidget(labelSizeH,              3, 0);
   layoutDescription->addWidget(labelSize,                 3, 1);

   layoutDescription->addWidget(labelTargetH,              1, 2);
   layoutDescription->addWidget(labelTarget,                  1, 3);
   layoutDescription->addWidget(labelDescriptionH,       2, 2);
   layoutDescription->addWidget(labelDescription,           2, 3);
   layoutDescription->addWidget(labelMimeTypeH,    3, 2);
   layoutDescription->addWidget(labelMimeType,       3, 3);


   layoutFilterRight->addWidget(labelTemplateFilterHRight, 1, 0);
   layoutFilterRight->addWidget(templateFilterRight, 1, 1);
   layoutFilterRight->addWidget(labelMimeFilterHRight, 2, 0);
   layoutFilterRight->addWidget(mimeFilterRight, 2, 1);
   layoutFilterRight->addWidget(labelAbcFilterHRight, 3, 0);
   layoutFilterRight->addWidget(abcFilterRight, 3, 1);

   layoutFilterLeft->addWidget(templateFilterLeft, 1, 0);
   layoutFilterLeft->addWidget(labelTemplateFilterHLeft, 1, 1);
   layoutFilterLeft->addWidget(mimeFilterLeft, 2, 0);
   layoutFilterLeft->addWidget(labelMimeFilterHLeft, 2, 1);
   layoutFilterLeft->addWidget(abcFilterLeft, 3, 0);
   layoutFilterLeft->addWidget(labelAbcFilterHLeft, 3, 1);


   mainLayout->addLayout(layoutFilterLeft);
   mainLayout->addStretch(1);
   mainLayout->addWidget(labelIcon);
   mainLayout->addLayout(layoutDescription);
   mainLayout->addStretch(1);
   mainLayout->addLayout(layoutFilterRight);
   shellLayout->addLayout(mainLayout);
   twofilter = true;

   MimeTypeString << "*" << "video/*" << "audio/*" << "image/*" << "text/*" << "text/html";
   MimeTypeComment << tr("All") << tr("Video") << tr("Audio") << tr("Image") << tr("Text") << tr("HTML");
   TemplateString << "*" << "*mpg *mpeg *avi *mkv *vob"
                               << "*wma *mp3 *ogg *flac *wav"
                               << "*png *gif *jpg *jpeg *gif *tiff *bmp *xpm *bmp"
                               << "*txt"
                               << "*htm *html *xml";
    TemplateComment << tr("All") << tr("Video") << tr("Audio") << tr("Image") << tr("Text") << tr("HTML");
    createFiltersMimeMenu();
    createFiltersTemplateMenu();

    ExcludeEvents = new CExcludeEvents(82, this);
    abcFilterRight->installEventFilter(ExcludeEvents);
    abcFilterLeft->installEventFilter(ExcludeEvents);
}

void CStatusBar :: createFiltersMimeMenu() {
    mimeMenuRight = new QMenu();
    mimeMenuLeft = new QMenu();
    QFont font;
    font.setBold(true);
    mimeFilterRight->setFont(font);
    mimeFilterRight->setText(MimeTypeComment[0]);
    mimeFilterLeft->setFont(font);
    mimeFilterLeft->setText(MimeTypeComment[0]);

    int i = 0;
    foreach ( QString str, MimeTypeString) {
      mimeMenuRight->addAction(MimeTypeComment[i] + " -- " + str, this, SLOT(clickMimeMenuRight()));
      mimeMenuLeft->addAction(MimeTypeComment[i] + " -- " + str, this, SLOT(clickMimeMenuLeft()));
      ++i;
    }
    if ( !MimeTypeStringUser.isEmpty()) {
      i = 0;
      mimeMenuRight->addSeparator();
      mimeMenuLeft->addSeparator();
      foreach ( QString str, MimeTypeStringUser ) {
        mimeMenuRight->addAction(MimeTypeCommentUser[i] + " -- " + str, this, SLOT(clickMimeMenuRight()));
        mimeMenuLeft->addAction(MimeTypeCommentUser[i] + " -- " + str, this, SLOT(clickMimeMenuLeft()));
        ++i;
      }
    }
    mimeMenuRight->addSeparator();
    ExcludeDirsMimeRight = mimeMenuRight->addAction(tr("Exclude folder"));
    ExcludeDirsMimeRight->setCheckable(true);
    ExcludeDirsMimeRight->setChecked(excludeDirsMimeRight);
    mimeMenuLeft->addSeparator();
    ExcludeDirsMimeLeft = mimeMenuLeft->addAction(tr("Exclude folder"));
    ExcludeDirsMimeLeft->setCheckable(true);
    ExcludeDirsMimeLeft->setChecked(excludeDirsMimeLeft);

    mimeMenuRight->addSeparator();
    mimeMenuLeft->addSeparator();
    QAction *actm = mimeMenuRight->addAction(*(pxCache->getIcon(193)), tr("Add/Remove filters"), this, SLOT(addRemoveFilters()));
    mimeMenuLeft->addAction(actm);
    actm->setToolTip("mime");

    mimeFilterRight->setMenu(mimeMenuRight);
    mimeFilterLeft->setMenu(mimeMenuLeft);
    mimeMenuRight->setPalette(this->palette());
    mimeMenuLeft->setPalette(this->palette());

    connect ( ExcludeDirsMimeLeft, SIGNAL(triggered()), SLOT(clickExcludeDirs()));
    connect ( ExcludeDirsMimeRight, SIGNAL(triggered()), SLOT(clickExcludeDirs()));
}

void CStatusBar :: createFiltersTemplateMenu() {
    templateMenuRight = new QMenu();
    templateMenuLeft = new QMenu();
    QFont font;
    font.setBold(true);
    templateFilterRight->setFont(font);
    templateFilterRight->setText(TemplateComment[0]);
    templateFilterLeft->setFont(font);
    templateFilterLeft->setText(TemplateComment[0]);

    int i = 0;
    foreach ( QString str, TemplateString) {
      templateMenuRight->addAction(TemplateComment[i] + " -- " + str, this, SLOT(clickTemplateMenuRight()));
      templateMenuLeft->addAction(TemplateComment[i] + " -- " + str, this, SLOT(clickTemplateMenuLeft()));
      ++i;
    }
    if ( !TemplateStringUser.isEmpty()) {
      i = 0;
      templateMenuRight->addSeparator();
      templateMenuLeft->addSeparator();
      foreach ( QString str, TemplateStringUser) {
        templateMenuRight->addAction(TemplateCommentUser[i] + " -- " + str, this, SLOT(clickTemplateMenuRight()));
        templateMenuLeft->addAction(TemplateCommentUser[i] + " -- " + str, this, SLOT(clickTemplateMenuLeft()));
        ++i;
      }
    }
    templateMenuRight->addSeparator();
    ExcludeDirsTemplateRight = templateMenuRight->addAction(tr("Exclude folder"));
    ExcludeDirsTemplateRight->setCheckable(true);
    ExcludeDirsTemplateRight->setChecked(excludeDirsTemplateRight);
    templateMenuLeft->addSeparator();
    ExcludeDirsTemplateLeft = templateMenuLeft->addAction(tr("Exclude folder"));
    ExcludeDirsTemplateLeft->setCheckable(true);
    ExcludeDirsTemplateLeft->setChecked(excludeDirsTemplateLeft);

    templateMenuRight->addSeparator();
    templateMenuLeft->addSeparator();
    QAction *actt = templateMenuRight->addAction(*(pxCache->getIcon(193)), tr("Add/Remove filters"), this, SLOT(addRemoveFilters()));
    templateMenuLeft->addAction(actt);
    actt->setToolTip("templ");

    templateFilterRight->setMenu(templateMenuRight);
    templateFilterLeft->setMenu(templateMenuLeft);
    templateMenuRight->setPalette(this->palette());
    templateMenuLeft->setPalette(this->palette());

    connect ( ExcludeDirsTemplateLeft, SIGNAL(triggered()), SLOT(clickExcludeDirs()));
    connect ( ExcludeDirsTemplateRight, SIGNAL(triggered()), SLOT(clickExcludeDirs()));
}


void CStatusBar :: setFontColor (QColor color) {
  Color = color;
  QPalette pal = this->palette();
  changeTextPalette(&pal, color);
  this->setPalette(pal);
  mimeMenuRight->setPalette(pal);
  templateMenuRight->setPalette(pal);
  mimeMenuLeft->setPalette(pal);
  templateMenuLeft->setPalette(pal);
}

void CStatusBar :: setBackColor(QColor color) {
  QPalette pal = this->palette();
  changeBackgroundPalette(&pal, darkerColor(color, 30));
  this->setPalette(pal);
  changeBackgroundPalette(&pal, darkerColor(color, 55));
  mimeMenuRight->setPalette(pal);
  templateMenuRight->setPalette(pal);
  mimeMenuLeft->setPalette(pal);
  templateMenuLeft->setPalette(pal);
}


void CStatusBar :: setFontSize() {
   QFontMetrics metric (*font);
   int w = metric.width("aaaaaaaaaa");
   int h = metric.height();
   h = h * 3 + 15 + metric.lineSpacing();
   mimeFilterRight->setMaximumWidth(w);
   templateFilterRight->setMaximumWidth(w);
   abcFilterRight->setMaximumWidth(w);
   mimeFilterLeft->setMaximumWidth(w);
   templateFilterLeft->setMaximumWidth(w);
   abcFilterLeft->setMaximumWidth(w);
   this->setFont(*font);
   this->setMinimumHeight(75);
   this->setMaximumHeight(h);
   setMaxSizes();
}


void CStatusBar :: refreshWrite(QDir dir, bool b) {
  if ( b )  {
    abcFilterRight->blockSignals(true);
    abcFilterRight->setText("");
    abcFilterRight->blockSignals(false);
    abcFilterLeft->blockSignals(true);
    abcFilterLeft->setText("");
    abcFilterLeft->blockSignals(false);
  }
  labelIcon->show();
  labelNameH->setText("<b>" + tr("Name:") + "</b>");
  labelTypeH->setText("<b>" + tr("Type:") + "</b>");
  labelModifiedH->setText("<b>" + tr("Modified:") + "</b>");
  QFileInfo fileinfo(dir.absolutePath());
  Template templ = pxCache->fullTemplate(fileinfo);
  if ( !fileinfo.isReadable() && !fileinfo.exists()) {
    QPainter painter;
    painter.begin(&(templ.Icon));
    painter.drawPixmap(32, 32, pxCache->getIcon(182)->scaled(64, 64));
    painter.end();

    labelIcon->setPixmap(templ.Icon.scaled(72,72));
    labelName->setText(templ.FileName);
    labelType->setText(templ.Type);
    labelModified->setText(templ.LastModified + "   ");
    labelSizeH->setText("");
    labelSize->setText("<b>" + tr("No permissions for read this") + "</b>");
    labelMimeTypeH->setText("");
    labelMimeType->setText("");
  }
  else {
    labelIcon->setPixmap(templ.Icon.scaled(72,72));
    labelName->setText(templ.FileName);
    labelType->setText(templ.Type);
    labelModified->setText(templ.LastModified + "   ");
    labelSizeH->setText("<b>" + tr("Size:") + "</b>");
    labelSize->setText(templ.Size);
    labelMimeTypeH->setText("<b>MIME:</b>");
    labelMimeType->setText(templ.Mime);
  }

  labelTargetH->setText("");
  labelTarget->setText("");
  labelDescriptionH->setText("");
  labelDescription->setText("");

  setMaxSizes();
}

void CStatusBar :: refreshWrite(QFileInfo fileinfo, bool b) {
  if ( b )  {
    abcFilterRight->blockSignals(true);
    abcFilterRight->setText("");
    abcFilterRight->blockSignals(false);
    abcFilterLeft->blockSignals(true);
    abcFilterLeft->setText("");
    abcFilterLeft->blockSignals(false);
  }

  labelIcon->show();
  labelNameH->setText("<b>" + tr("Name:") + "</b>");
  labelTypeH->setText("<b>" + tr("Type:") + "</b>");
  labelModifiedH->setText("<b>" + tr("Modified:") + "</b>");
  if ( !fileinfo.isReadable() && fileinfo.exists()) {
    Template templ = pxCache->fullTemplate(fileinfo);
    QPainter painter;
    painter.begin(&(templ.Icon));
    painter.drawPixmap(32, 32, pxCache->getIcon(182)->scaled(64, 64));
    painter.end();
    labelIcon->setPixmap(templ.Icon.scaled(72,72));
    labelName->setText(templ.FileName);
    labelType->setText(templ.Type);
    labelMimeTypeH->setText("");
    labelMimeType->setText("");
    labelModified->setText(templ.LastModified + "    ");
    labelSizeH->setText("");
    labelSize->setText("<b>" + tr("No permissions for read this") + "</b>");

    if ( templ.SymLink ) {
      labelTargetH->setText("<b>" + tr("Target on:") + "</b>");
      labelTarget->setText(templ.TargetLink);
      labelDescriptionH->setText("<b>" + tr("Description:") + "</b>");
      labelDescription->setText(templ.Descr);
      labelMimeType->setText("");
    }
    else {
      if ( fileinfo.isDir()) {
	  labelTargetH->setText("");
	  labelTarget->setText("");
	  labelDescriptionH->setText("");
	  labelDescription->setText("");
      }
      else {
	  labelTargetH->setText("");
	  labelTarget->setText("");
	  labelDescriptionH->setText("<b>" + tr("Description:") + "</b>");
	  labelDescription->setText(templ.Descr);
      }
    }
  }
  else {
    Template templ = pxCache->fullTemplate(fileinfo);
    labelIcon->setPixmap(templ.Icon.scaled(72,72));
    labelName->setText(templ.FileName);
    labelType->setText(templ.Type);
    labelMimeTypeH->setText("<b>" + tr("MIME:") + "</b>");
    labelMimeType->setText(templ.Mime);
    labelModified->setText(templ.LastModified + "    ");
    labelSizeH->setText("<b>" + tr("Size:") + "</b>");
    labelSize->setText(templ.Size);

    if ( templ.SymLink ) {
      labelTargetH->setText("<b>" + tr("Target on:") + "</b>");
      labelTarget->setText(templ.TargetLink);
      labelDescriptionH->setText("<b>" + tr("Description:") + "</b>");
      labelDescription->setText(templ.Descr);
      labelMimeType->setText(templ.Mime);
    }
    else {
      if ( fileinfo.isDir()) {
	  labelTargetH->setText("");
	  labelTarget->setText("");
	  labelDescriptionH->setText("");
	  labelDescription->setText("");
      }
      else {
	  labelTargetH->setText("");
	  labelTarget->setText("");
	  labelDescriptionH->setText("<b>" + tr("Description:") + "</b>");
	  labelDescription->setText(templ.Descr);
      }
    }
  }

   setMaxSizes();
}

void CStatusBar :: refreshWrite() {
    abcFilterRight->blockSignals(true);
    abcFilterRight->setText("");
    abcFilterRight->blockSignals(false);
    abcFilterLeft->blockSignals(true);
    abcFilterLeft->setText("");
    abcFilterLeft->blockSignals(false);

    labelIcon->hide();
    labelNameH->setText("");
    labelName->setText("");
    labelTypeH->setText("");
    labelType->setText("");
    labelModifiedH->setText("");
    labelModified->setText("");
    labelTargetH->setText("");
    labelTarget->setText("");
    labelDescriptionH->setText("");
    labelDescription->setText("");
    labelMimeTypeH->setText("");
    labelMimeType->setText("");
    labelSizeH->setText("");
    labelSize->setText(QString("       ") + "<h3>" + tr("No selected object's") + "</h3>");

    setMaxSizes();
}

void CStatusBar :: refreshWrite(int n) {
    abcFilterRight->blockSignals(true);
    abcFilterRight->setText("");
    abcFilterRight->blockSignals(false);
    abcFilterLeft->blockSignals(true);
    abcFilterLeft->setText("");
    abcFilterLeft->blockSignals(false);

    labelIcon->show();
    labelIcon->setPixmap(pxCache->getIcon(10)->scaled(72,72));
    labelNameH->setText("");
    labelName->setText("");
    labelTypeH->setText("");
    labelType->setText("");
    labelModifiedH->setText("");
    labelModified->setText("<h3>" + QString::number(n) + " " + tr("items selected") + "</h3>");
    labelTargetH->setText("");
    labelTarget->setText("");
    labelDescriptionH->setText("");
    labelDescription->setText("");
    labelMimeTypeH->setText("");
    labelMimeType->setText("");
    labelSizeH->setText("");
    labelSize->setText("");

    setMaxSizes();
}

void CStatusBar :: setTextAbcRight(QString str) {
  abcFilterRight->setText(abcFilterRight->text() + str);
}

void CStatusBar :: setTextAbcLeft(QString str) {
  abcFilterLeft->setText(abcFilterLeft->text() + str);
}

void CStatusBar :: delSymbolAbcRight() {
  int n = abcFilterRight->text().length();
  abcFilterRight->setText(abcFilterRight->text().remove(n - 1, 1));
}

void CStatusBar :: delSymbolAbcLeft() {
  int n = abcFilterLeft->text().length();
  abcFilterLeft->setText(abcFilterLeft->text().remove(n - 1, 1));
}

void CStatusBar :: clickMimeMenuRight() {
  QAction *action = qobject_cast<QAction*>(sender());
  QString string = action->text();
  QStringList lst = string.split(" -- ");
  if ( lst.count() == 2 ) {
    mimeFilterRight->setText(lst[0]);
    emit changeMimeFilterRight(lst[1]);
    templateFilterRight->setText(TemplateComment[0]);
  }
  else {
    mimeFilterRight->setText(lst[0]);
    emit changeMimeFilterRight(lst[0]);
    templateFilterRight->setText(TemplateComment[0]);
  }
}

void CStatusBar :: clickMimeMenuLeft() {
  QAction *action = qobject_cast<QAction*>(sender());
  QString string = action->text();
  QStringList lst = string.split(" -- ");
  if ( lst.count() == 2 ) {
    mimeFilterLeft->setText(lst[0]);
    emit changeMimeFilterLeft(lst[1]);
    templateFilterLeft->setText(TemplateComment[0]);
  }
  else {
    mimeFilterLeft->setText(lst[0]);
    emit changeMimeFilterLeft(lst[0]);
    templateFilterLeft->setText(TemplateComment[0]);
  }
}

void CStatusBar :: clickTemplateMenuRight() {
  QAction *action = qobject_cast<QAction*>(sender());
  QString string = action->text();
  QStringList lst = string.split(" -- ");
  if ( lst.count() == 2 ) {
    templateFilterRight->setText(lst[0]);
    emit changeTemplateFilterRight(lst[1]);
    mimeFilterRight->setText(MimeTypeComment[0]);
  }
  else {
    templateFilterRight->setText(lst[0]);
    emit changeTemplateFilterRight(lst[0]);
    mimeFilterRight->setText(MimeTypeComment[0]);
  }
}

void CStatusBar :: clickTemplateMenuLeft() {
  QAction *action = qobject_cast<QAction*>(sender());
  QString string = action->text();
  QStringList lst = string.split(" -- ");
  if ( lst.count() == 2 ) {
    templateFilterLeft->setText(lst[0]);
    emit changeTemplateFilterLeft(lst[1]);
    mimeFilterLeft->setText(MimeTypeComment[0]);
  }
  else {
    templateFilterLeft->setText(lst[0]);
    emit changeTemplateFilterLeft(lst[0]);
    mimeFilterLeft->setText(MimeTypeComment[0]);
  }
}

void CStatusBar :: setOneFilter() {
  if ( twofilter == true) {
    labelAbcFilterHLeft->hide();
    labelMimeFilterHLeft->hide();
    labelTemplateFilterHLeft->hide();
    abcFilterLeft->hide();
    templateFilterLeft->hide();
    mimeFilterLeft->hide();
    mainLayout->removeItem(mainLayout->itemAt(1));
    twofilter = false;
  }
}

void CStatusBar :: setTwoFilter() {
  if ( twofilter == false) {
    labelAbcFilterHLeft->show();
    labelMimeFilterHLeft->show();
    labelTemplateFilterHLeft->show();
    abcFilterLeft->show();
    templateFilterLeft->show();
    mimeFilterLeft->show();
    mainLayout->insertStretch(1, 1);
    mimeFilterLeft->setText(MimeTypeComment[0]);
    templateFilterLeft->setText(TemplateComment[0]);
    abcFilterLeft->setText("");
    twofilter = true;
  }
}

void CStatusBar :: hideRightFilter(bool vis) {
  if ( vis ) {
    labelAbcFilterHRight->hide();
    labelMimeFilterHRight->hide();
    labelTemplateFilterHRight->hide();
    abcFilterRight->hide();
    templateFilterRight->hide();
    mimeFilterRight->hide();
  }
  else {
    labelAbcFilterHRight->show();
    labelMimeFilterHRight->show();
    labelTemplateFilterHRight->show();
    abcFilterRight->show();
    templateFilterRight->show();
    mimeFilterRight->show();
  }
}

void CStatusBar :: hideLeftFilter(bool vis) {
  if ( !twofilter ) return;
  if ( vis ) {
    labelAbcFilterHLeft->hide();
    labelMimeFilterHLeft->hide();
    labelTemplateFilterHLeft->hide();
    abcFilterLeft->hide();
    templateFilterLeft->hide();
    mimeFilterLeft->hide();
  }
  else {
    labelAbcFilterHLeft->show();
    labelMimeFilterHLeft->show();
    labelTemplateFilterHLeft->show();
    abcFilterLeft->show();
    templateFilterLeft->show();
    mimeFilterLeft->show();
  }
}

void CStatusBar :: setMaxSizes() {
  QList<int> Sizes;
  FilterSize = NameSize = MimeSize = 0;
  Sizes << templateFilterRight->width() + labelTemplateFilterHRight->width();
  Sizes << mimeFilterRight->width() + labelMimeFilterHRight->width();
  Sizes << abcFilterRight->width() + labelAbcFilterHRight->width();
  foreach ( int i, Sizes)     if ( FilterSize < i ) FilterSize = i;
  Sizes.clear();
  Sizes << labelNameH->width() << labelTypeH->width() << labelModifiedH->width() << labelSizeH->width();
  foreach ( int i, Sizes )   if ( NameSize < i ) NameSize = i;
  Sizes.clear();
  if ( !labelDescriptionH->isHidden()) Sizes << labelDescriptionH->sizeHint().width();
  if ( !labelTargetH->isHidden()) Sizes << labelTargetH->sizeHint().width();
  if ( !labelMimeTypeH->isHidden()) Sizes << labelMimeTypeH->sizeHint().width();
  foreach ( int i, Sizes ) if ( MimeSize < i ) MimeSize = i;
  Sizes.clear();
  int ww = 0;
  Sizes << labelType->width() << labelSize->width() << labelModified->width();
  foreach ( int i, Sizes) if (ww < i) ww = i;
  if ( twofilter ) {
    int maxwidth = this->width() - (FilterSize*2 + NameSize + labelIcon->width() + 100);
    if ( maxwidth <= 0 ) maxwidth = 0;
    labelName->setMaximumWidth(maxwidth);
    maxwidth = maxwidth - ww - MimeSize;
    if ( maxwidth <= 0 ) maxwidth = 0;
    labelTarget->setMaximumWidth(maxwidth);
    labelMimeType->setMaximumWidth(maxwidth);
    labelDescription->setMaximumWidth(maxwidth);
  }
  else {
    int maxwidth = this->width() - (FilterSize + NameSize + labelIcon->width() + 70);
    if ( maxwidth <= 0 ) maxwidth = 0;
    labelName->setMaximumWidth(maxwidth);
    maxwidth = maxwidth - ww - MimeSize;
    if ( maxwidth <= 0 ) maxwidth = 0;
    labelTarget->setMaximumWidth(maxwidth);
    labelMimeType->setMaximumWidth(maxwidth);
    labelDescription->setMaximumWidth(maxwidth);
  }
}

void CStatusBar :: resizeEvent(QResizeEvent *ev) {
  QWidget::resizeEvent(ev);
  setMaxSizes();
}

void CStatusBar :: clickExcludeDirs() {
  QAction *act = qobject_cast<QAction*>(sender());
  if ( act == ExcludeDirsMimeLeft ) {
    excludeDirsMimeLeft = ExcludeDirsMimeLeft->isChecked();
    emit changeExcludeDirsMimeLeft(excludeDirsMimeLeft);
    return;
  }
  if ( act == ExcludeDirsTemplateLeft ) {
    excludeDirsTemplateLeft = ExcludeDirsTemplateLeft->isChecked();
    emit changeExcludeDirsTemplateLeft(excludeDirsTemplateLeft);
    return;
  }
  if ( act == ExcludeDirsMimeRight ) {
    excludeDirsMimeRight = ExcludeDirsMimeRight->isChecked();
    emit changeExcludeDirsMimeRight(excludeDirsMimeRight);
    return;
  }
  if ( act == ExcludeDirsTemplateRight ) {
    excludeDirsTemplateRight = ExcludeDirsTemplateRight->isChecked();
    emit changeExcludeDirsTemplateRight(excludeDirsTemplateRight);
    return;
  }
}

void CStatusBar :: readSettings() {
  QSettings settings;
  settings.beginGroup("/Bathyscaphe");
  excludeDirsMimeLeft = settings.value("/ExcludeDirsMimeLeft", false).toBool();
  excludeDirsTemplateLeft = settings.value("/ExcludeDirsTemplateLeft", false).toBool();
  excludeDirsMimeRight = settings.value("/ExcludeDirsMimeRight", false).toBool();
  excludeDirsTemplateRight = settings.value("/ExcludeDirsTemplateRight", false).toBool();

  QByteArray byteArr = settings.value("/ByteArrayFilter", QByteArray()).toByteArray();
  QDataStream stream(&byteArr, QIODevice::ReadOnly);
  stream >> MimeTypeStringUser;
  stream >> MimeTypeCommentUser;
  stream >> TemplateStringUser;
  stream >> TemplateCommentUser;
  settings.endGroup();
}

void CStatusBar :: writeSettings() {
  QSettings settings;
  settings.beginGroup("/Bathyscaphe");
  settings.setValue("/ExcludeDirsMimeLeft", excludeDirsMimeLeft);
  settings.setValue("/ExcludeDirsTemplateLeft", excludeDirsTemplateLeft);
  settings.setValue("/ExcludeDirsMimeRight", excludeDirsMimeRight);
  settings.setValue("/ExcludeDirsTemplateRight", excludeDirsTemplateRight);

  QByteArray byteArr;
  QDataStream stream(&byteArr, QIODevice::WriteOnly);
  stream << MimeTypeStringUser;
  stream << MimeTypeCommentUser;
  stream << TemplateStringUser;
  stream << TemplateCommentUser;
  settings.setValue("/ByteArrayFilter", byteArr);
  settings.endGroup();
}

//-----------------                      Functions of filters                                    ---------------------------------------------------------------

void CStatusBar :: addRemoveFilters() {
  dialogWnd = new QDialog(this);
  CTryEvent *tryEvent = new CTryEvent(dialogWnd);
  dialogWnd->installEventFilter(tryEvent);
  dialogWnd->setWindowTitle("Add/Remove filters - Bathyscaphe");
  dialogWnd->setWindowIcon(*(pxCache->getMainIcon(3)));
  QAction *act = qobject_cast<QAction*>(sender());
  dialogWnd->setPalette(this->palette());
  dialogWnd->setFont(*font);

  mainFiltersLayout = new QVBoxLayout(dialogWnd);
  filterViewBox = new QGroupBox();
  filterViewLayout = new QVBoxLayout();
  filterViewBox->setLayout(filterViewLayout);
  viewFilter = new QTreeWidget();
  filterViewLayout->addWidget(viewFilter);
  viewFilter->setRootIsDecorated(false);
  if ( act->toolTip() == "mime") {
    mainFiltersLayout->addWidget(new QLabel("<h4 align = center>" + tr("Adding and removing MIME filters") + "</h4>"));
    QStringList lst;
    lst << tr("Name") << tr("MIME-type");
    viewFilter->setHeaderLabels(lst);
    int i = 0;
    foreach ( QString str, MimeTypeCommentUser) {
      item = new QTreeWidgetItem(viewFilter);
      item->setText(0, str);
      item->setText(1, MimeTypeStringUser[i]);
      ++i;
    }
    MimeFilter = true;
  }
  else {
    mainFiltersLayout->addWidget(new QLabel("<h4 align = center>" + tr("Adding and removing template filters") + "</h4>"));
    QStringList lst;
    lst << tr("Name") << tr("Template");
    viewFilter->setHeaderLabels(lst);
    int i = 0;
    foreach ( QString str, TemplateCommentUser) {
      item = new QTreeWidgetItem(viewFilter);
      item->setText(0, str);
      item->setText(1, TemplateStringUser[i]);
      ++i;
    }
    MimeFilter = false;
  }

 buttonsLayout = new QHBoxLayout();
 newButton = new QPushButton(*(pxCache->getIcon(80)), tr("New"));
 removeButton = new QPushButton(*(pxCache->getIcon(82)), tr("Remove"));
 editButton = new QPushButton(*(pxCache->getIcon(85)), tr("Edit"));
 closeButton = new QPushButton(*(pxCache->getIcon(86)), tr("Close"));
 removeButton->setEnabled(false);
 editButton->setEnabled(false);

 buttonsLayout->addWidget(newButton);
 buttonsLayout->addWidget(removeButton);
 buttonsLayout->addWidget(editButton);
 buttonsLayout->addWidget(closeButton);

 addedBox = new QGroupBox();
 addedLayout = new QGridLayout();
 nameEdit = new QLineEdit();
 filterEdit = new QLineEdit();
 nameEdit->installEventFilter(ExcludeEvents);
 filterEdit->installEventFilter(ExcludeEvents);
 nameLabel = new QLabel("<b>" + tr("Input name of filter:") + "</b>");
 filterLabel = new QLabel("<b>" + tr("Input filter:") + "</b>");
 addedLayout->addWidget(nameLabel, 0, 0);
 addedLayout->addWidget(nameEdit, 0, 1);
 addedLayout->addWidget(filterLabel, 1, 0);
 addedLayout->addWidget(filterEdit, 1, 1);
 addedButtonsLayout = new QHBoxLayout();
 okButton = new QPushButton(*(pxCache->getIcon(190)), tr("Ok"));
 cancelButton = new QPushButton(*(pxCache->getIcon(191)), tr("Cancel"));
 addedButtonsLayout->addWidget(okButton);
 addedButtonsLayout->addStretch(1);
 addedButtonsLayout->addWidget(cancelButton);
 addedBox->setLayout(addedLayout);

 mainFiltersLayout->addWidget(filterViewBox);
 mainFiltersLayout->addLayout(buttonsLayout);
 mainFiltersLayout->addWidget(addedBox);
 mainFiltersLayout->addLayout(addedButtonsLayout);

 connect (newButton, SIGNAL(clicked()), SLOT(createNewFilter()));
 connect (removeButton, SIGNAL(clicked()), SLOT(removeFilter()));
 connect (editButton, SIGNAL(clicked()), SLOT(editFilter()));
 connect (closeButton, SIGNAL(clicked()), SLOT(closeWindowFilter()));
 connect (cancelButton, SIGNAL(clicked()), SLOT(hideFiltersPanel()));
 connect (okButton, SIGNAL(clicked()), SLOT(setFileFilter()));
 connect (viewFilter, SIGNAL(itemActivated(QTreeWidgetItem*, int)), SLOT(activatedItem(QTreeWidgetItem*)));
 connect (viewFilter, SIGNAL(itemClicked(QTreeWidgetItem*, int)), SLOT(activatedItem(QTreeWidgetItem*)));
 connect (nameEdit, SIGNAL(textChanged(QString)), SLOT(filterEditChanged()));
 connect (filterEdit, SIGNAL(textChanged(QString)), SLOT(filterEditChanged()));
 connect (tryEvent, SIGNAL(closeWnd()), SLOT(closeWindowFilter()));

 fH = nameEdit->sizeHint().height() *2 + okButton->sizeHint().height() + 30;
 addedBox->hide();
 okButton->hide();
 cancelButton->hide();
 dialogWnd->setModal(true);
 dialogWnd->exec();
 delete dialogWnd;
}

void CStatusBar :: closeWindowFilter() {
  if ( MimeFilter ) {
    delete mimeMenuRight;
    delete mimeMenuLeft;
    createFiltersMimeMenu();
    emit changeMimeFilterRight(MimeTypeString[0]);
    emit changeMimeFilterLeft(MimeTypeString[0]);
    templateFilterRight->setText(TemplateComment[0]);
    templateFilterLeft->setText(TemplateComment[0]);
  }
  else {
    delete templateMenuRight;
    delete templateMenuLeft;
    createFiltersTemplateMenu();
    emit changeTemplateFilterRight(TemplateString[0]);
    emit changeTemplateFilterLeft(TemplateString[0]);
    mimeFilterRight->setText(MimeTypeComment[0]);
    mimeFilterLeft->setText(MimeTypeComment[0]);
  }
  dialogWnd->accept();
}

void CStatusBar :: createNewFilter() {
  addedBox->show();
  okButton->show();
  cancelButton->show();
  newButton->setEnabled(false);
  removeButton->setEnabled(false);
  editButton->setEnabled(false);
  okButton->setEnabled(false);
  viewFilter->blockSignals(true);
  nameEdit->setText("");
  filterEdit->setText("");
  dialogWnd->resize(dialogWnd->width(), dialogWnd->height() + fH);
  op = 'C';
}

void CStatusBar :: hideFiltersPanel() {
 addedBox->hide();
 okButton->hide();
 cancelButton->hide();
 newButton->setEnabled(true);
 viewFilter->blockSignals(false);
 viewFilter->setEnabled(true);
 if ( !(viewFilter->selectedItems().isEmpty())) {
   editButton->setEnabled(true);
   removeButton->setEnabled(true);
 }
 dialogWnd->resize(dialogWnd->width(), dialogWnd->height() - fH);
}

void CStatusBar :: filterEditChanged() {
  if (nameEdit->text() == "" || filterEdit->text() == "") {
    okButton->setEnabled(false);
    return;
  }
  else {
    okButton->setEnabled(true);
    return;
  }
}

void CStatusBar :: removeFilter() {
  QList<QTreeWidgetItem*> lstitem = viewFilter->selectedItems();
  if (lstitem.isEmpty()) {
    editButton->setEnabled(false);
    removeButton->setEnabled(false);
    return;
  }
  QString currentfilter = lstitem[0]->text(0);
  int i = 0;
  if(MimeFilter) {
    foreach ( QString str, MimeTypeCommentUser) {
      if (str == currentfilter) {
        MimeTypeStringUser.removeAt(i);
        MimeTypeCommentUser.removeAt(i);
        delete lstitem[0];
        break;
      }
      ++i;
    }
  }
  else {
    foreach ( QString str, TemplateCommentUser) {
      if (str == currentfilter) {
        TemplateStringUser.removeAt(i);
        TemplateCommentUser.removeAt(i);
        delete lstitem[0];
      }
      ++i;
    }
  }
  editButton->setEnabled(false);
  removeButton->setEnabled(false);
}

void CStatusBar :: setFileFilter() {
  if ( op == 'C' ) {
    if (MimeFilter) {
      foreach ( QString str, MimeTypeCommentUser) {
        if ( nameEdit->text() == str ) {
          showErrorFilter();
          return;
        }
      }
      MimeTypeCommentUser << nameEdit->text();
      MimeTypeStringUser << filterEdit->text();
      QTreeWidgetItem *itt = new QTreeWidgetItem(viewFilter);
      itt->setText(0, nameEdit->text());
      itt->setText(1, filterEdit->text());
      hideFiltersPanel();
    }
    else {
      foreach ( QString str, TemplateCommentUser ) {
        if ( nameEdit->text() == str ) {
          showErrorFilter();
          return;
        }
      }
      TemplateCommentUser << nameEdit->text();
      TemplateStringUser << filterEdit->text();
      QTreeWidgetItem *itt = new QTreeWidgetItem(viewFilter);
      itt->setText(0, nameEdit->text());
      itt->setText(1, filterEdit->text());
      hideFiltersPanel();
    }
  }
  if ( op == 'E' ) {
    int index = 0, i = 0;
    if ( MimeFilter ) {
      foreach ( QString str, MimeTypeCommentUser) {
        if ( nname == str ) break;
        ++index;
      }
      foreach ( QString str, MimeTypeCommentUser) {
        if ( nameEdit->text() == str ) break;
        ++i;
      }
      if ( index != i ) {
       showErrorFilter();
       return;
      }
      item->setText(0, nameEdit->text());
      item->setText(1, filterEdit->text());
      MimeTypeCommentUser[index] = nameEdit->text();
      MimeTypeStringUser[index] = filterEdit->text();
      hideFiltersPanel();
    }
    else {
      foreach ( QString str, TemplateCommentUser) {
        if ( nname == str ) break;
        ++index;
      }
      foreach ( QString str, TemplateCommentUser) {
        if ( nameEdit->text() == str ) break;
        ++i;
      }
      if ( index != i ) {
       showErrorFilter();
       return;
      }
      item->setText(0, nameEdit->text());
      item->setText(1, filterEdit->text());
      TemplateCommentUser[index] = nameEdit->text();
      TemplateStringUser[index] = filterEdit->text();
      hideFiltersPanel();
    }
  }
}

void CStatusBar :: editFilter() {
  QList<QTreeWidgetItem*> lstitem = viewFilter->selectedItems();
  if ( lstitem.isEmpty()) {
    editButton->setEnabled(false);
    removeButton->setEnabled(false);
    return;
  }
  createNewFilter();
  item = lstitem[0];
  viewFilter->setEnabled(false);
  nameEdit->setText(lstitem[0]->text(0));
  filterEdit->setText(lstitem[0]->text(1));
  nname = nameEdit->text();
  nfilter = filterEdit->text();
  op = 'E';
}

void CStatusBar :: activatedItem(QTreeWidgetItem* it ) {
  item = it;
  editButton->setEnabled(true);
  removeButton->setEnabled(true);
}

void CStatusBar :: showErrorFilter() {
  QDialog *errorDialog = new QDialog(this);
  QVBoxLayout *vlay = new QVBoxLayout();
  QHBoxLayout *hlay = new QHBoxLayout();
  QLabel *licon = new QLabel();
  licon->setPixmap(pxCache->getIcon(182)->scaled(96,96));
  QLabel *ltext = new QLabel("<h4>" + tr("Filter with this name already exists.") + "<br>" + tr(" Please, give another name for filter.") + "</h4>");
  QPushButton *cbutton = new QPushButton(*(pxCache->getIcon(191)), tr("Close"));
  hlay->addWidget(licon);
  hlay->addWidget(ltext);
  vlay->addLayout(hlay);
  vlay->addWidget(cbutton);
  errorDialog->setLayout(vlay);
  errorDialog->setPalette(this->palette());
  connect (cbutton, SIGNAL(clicked()), errorDialog, SLOT(accept()));
  errorDialog->exec();
  delete errorDialog;
}

CStatusBar :: ~CStatusBar() {
  writeSettings();
}






