#include "../../Include/WebViewer.h"
#include "../../Include/ExcludeEvents.h"

CWebViewer :: CWebViewer(QWidget * wgt) : QWebView(wgt) {
  AddHistory = true;
  PageEncoding = QWebSettings::globalSettings()->defaultTextEncoding();
  GroupCodecsMenu = new QMenu();

  QStringList Codecs;
  Codecs                                <<       tr("Western Europe") + "                       || IBM 850                          || ibm-850                      || 1"
                                                <<       tr("Western Europe") + "                       || ISO 8859-1                     || iso-8859-1                 || 1"
                                                <<       tr("Western Europe") + "                       || ISO 8859-14                   || iso-8859-14              || 1"
                                                <<       tr("Western Europe") + "                        || ISO 8859-15                   || iso-8859-15              || 1"
                                                <<       tr("Western Europe") + "                        || CP-1252                        || cp-1252                     || 1"

                                                <<       tr("Central Europe") + "                          || CP-1250                         || cp-1250                     || 2"
                                                <<       tr("Central Europe") + "                          || ISO 8859-2                     || iso-8859-2                 || 2"
                                                <<       tr("Central Europe") + "                          || ISO 8859-3                     || iso-8859-3                 || 2"

                                                <<       tr("South-Eastern Europe") + "               || ISO 8859-16                   || iso-8859-16               || 3"

                                                <<       tr("Baltic") + "                                             || ISO 8859-4                     || iso-8859-4                  || 4"
                                                <<       tr("Baltic") + "                                             || ISO 8859-13                   || iso-8859-13               || 4"
                                                <<       tr("Baltic") + "                                              || CP-1257                         || cp-1257                      || 4"

                                                <<       tr("Chinese") + "                                         || Big5                                  || big5                             || 5"
                                                <<       tr("Chinese") + "                                         || Big5-HKSCS                   || big5-hkscs                  || 5"
                                                <<       tr("Chinese") + "                                         || GB18030-0                     || gb-18030-0                  || 5"

                                                <<       tr("Japanese") + "                                       || EUC-JP                            || euc-jp                          || 6"
                                                <<       tr("Japanese") + "                                       || ISO 2022-JP                   || iso-2022-jp                 || 6"

                                                <<       tr("Korean") + "                                            || EUC-KR                          || euc-kr                            || 7"

                                                <<       tr("Thai") + "                                                 || iso-8859-11                     || iso-8859-11                || 8"
                                                <<       tr("Thai") + "                                                 || TIS-620                           || tis-620                          || 8"


                                                <<       tr("Cirillic") + "                                               || IBM 866                          || ibm-866                          || 9"
                                                <<       tr("Cirillic") + "                                               || ISO 8859-5                     || iso-8859-5                    || 9"
                                                <<       tr("Cirillic") + "                                               || KOI8-R                           || koi8-r                               || 9"
                                                <<       tr("Cirillic") + "                                               || KOI8-U                           || koi8-u                             || 9"
                                                <<       tr("Cirillic") + "                                               || CP-1251                        || cp-1251                         || 9"

                                                <<       tr("Greek") + "                                                || CP-1253                        || cp-1253                          || 10"
                                                <<       tr("Greek") + "                                                || ISO 8859-7                     || iso-8859-7                     || 10"

                                                <<       tr("Arabic") + "                                                || ISO 8859-6                     || iso-8859-6                      || 11"
                                                <<       tr("Arabic") + "                                                || CP-1256                         || cp-1256                          || 11"

                                                <<       tr("Turkish") + "                                               || ISO 8859-9                     || iso-8859-9                     || 12"
                                                <<       tr("Turkish") + "                                               || CP-1254                         || cp-1254                          || 12"

                                                <<       tr("Hebrew") + "                                              || ISO 8859-8                     || iso-8859-8                      || 13"
                                                <<       tr("Hebrew") + "                                              || CP-1255                         || cp-1255                           || 13"

                                                <<       tr("Unicode") + "                                             || UTF-8                             || utf-8                                  || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-16                           || utf-16                                || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-16BE                      || utf-16be                           || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-16LE                      || utf-16le                             || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-32                           || utf-32                                || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-32BE                     || utf-32be                            || 14"
//                                                <<       tr("Unicode") + "                                           || UTF-32LE                      || utf-32le                             || 14"

                                                <<       tr("north Sami") + "                                         || WINSAMI2                      ||winsami2                          || 15"

                                                <<       tr("Other") + "                                                   || TSCII                               || tscii                                    || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Bng                          || Iscii-bng                            || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Dev                          || Iscii-dev                            || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Gjr                            || Iscii-gjr                              || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Knd                          || Iscii-knd                            || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Mlm                         || Iscii-Mlm                            || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Ori                           || Iscii-ori                               || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Pnj                           || Iscii-pnj                              || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Tlg                           || lscii-tlg                               || 16"
                                                <<       tr("Other") + "                                                   || Iscii-Tml                          || Iscii-tml                               || 16"
                                                <<       tr("Other") + "                                                   || JIS X 0201                     || jis-x-0201                           || 16"
                                                <<       tr("Other") + "                                                   || JIS X 0208                     || jis-x-0208                           || 16"
                                                <<       tr("Other") + "                                                   || MuleLao-1                      || mulelao-1                          || 16"
                                                <<       tr("Other") + "                                                   || ROMAN8                        || roman8                              || 16"
                                                <<       tr("Other") + "                                                   || Shift-JIS                          || shif-jis                                 || 16"
                                                <<       tr("Other") + "                                                   || CP-1258                         || cp-1258                              || 16"
                                                <<       tr("Other") + "                                                   || CP-1259                         || cp-1259                              || 16"
                                                <<       tr("Other") + "                                                   || IBM 874                           || ibm-847                             || 16"
                                                <<       tr("Other") + "                                                   || ISO 8859-10                   || iso-8859-10                       || 16"
                                                <<       tr("Other") + "                                                   || CP949                             || cp-949                                || 16";

   QString enc = QWebSettings::globalSettings()->defaultTextEncoding();
   QStringList templist, tempid, GroupPages;
   QAction *act;
   QString lastid;
   int n;
   for ( int i = 0; i < Codecs.count(); ++i ) {
     templist = Codecs[i].split("||");
     for ( int j = 0; j < 4; ++j ) templist[j] = templist[j].trimmed();
     if (!tempid.contains(templist[3])) {
       lastid = templist[3];
       tempid << lastid;
       QMenu *CodecMenu = new QMenu(GroupCodecsMenu);
       ListMenu << CodecMenu;
       GroupCodecsMenu->addMenu(CodecMenu)->setText(templist[0]);
       act = CodecMenu->addAction(templist[1]);
       act->setToolTip(templist[2]);
       if ( templist[2] == enc) EncodingAct = act;
       connect ( act, SIGNAL(triggered()), SLOT(changeEncoding()));
       n = i + 1;
       while ( n < Codecs.count()) {
         templist = Codecs[n].split("||");
         for ( int k = 0; k < 4; ++k ) templist[k] = templist[k].trimmed();
         if ( templist[3] == lastid ) {
           act = CodecMenu->addAction(templist[1]);
           act->setToolTip(templist[2]);
           if ( templist[2] == enc) EncodingAct = act;
           connect ( act, SIGNAL(triggered()), SLOT(changeEncoding()));
         }
        ++n;
       }
     }
   }
}


void CWebViewer :: loadingComplete(bool ok) {
  if ( !ok ) {
    this->setHtml( "<html> <head> <title>" + tr("Page not found") + " </title> </head>                                                                                            \
                                <body> <h3>" + tr("Page not found") + "</h3> <hr>" + tr("Could not found resourses:") + "  " + lastAdress.toString(), lastAdress);
  WebViewerTool->LoadProgressState->setText(tr("Error"));
  WebViewerTool->LoadProgress->reset();
  }
  else {
    this->page()->setLinkDelegationPolicy(QWebPage::DelegateAllLinks);
    WebViewerTool->LoadProgressState->setText(tr("Complete"));
    WebViewerTool->LoadProgress->setValue(100);
  }
  if ( AddHistory ) addHistoryItem();
  AddHistory = false;
}



void CWebViewer :: goAdress(QUrl Url ) {
  AddHistory = true;
  lastAdress = Url;
  this->load(lastAdress);
}

void CWebViewer :: goAdress() {
  AddHistory = true;
  QAction *action = qobject_cast<QAction*>(sender());
  lastAdress = QUrl(action->toolTip());
  this->load(lastAdress);
}

void CWebViewer :: contextMenuEvent(QContextMenuEvent*) {
}

void CWebViewer :: setToolAndHistory ( CWebViewerTool *tool, CWebHistory *history, QLineEdit * status ) {
  WebViewerTool = tool;
  WebHistory = history;
  WebViewerStatus = status;
  CExcludeEvents *ExEvents = new CExcludeEvents(82, this);
  WebViewerStatus->installEventFilter(ExEvents);
  WebViewerStatus->setMaximumHeight(WebViewerTool->size().height());
  WebViewerStatus->setMinimumHeight(WebViewerTool->size().height());
  int i = WebHistory->count();
  QAction * action;
  for ( int n = 0; n < i; ++n ) {
    action = WebViewerTool->WebHistoryMenu->addAction(WebHistory->icon(n),
                                                                                                        WebHistory->title(n),
                                                                                                        this,
                                                                                                        SLOT(goAdress()));
    action->setToolTip(WebHistory->link(n));
  }

  WebViewerTool->ScalePage->setText(QString::number(Scale * 100) + "%");
  setZoomFactor(Scale);
  if ( Scale >= 2. ) WebViewerTool->ScaleButtonPlus->setEnabled(false);
    else WebViewerTool->ScaleButtonPlus->setEnabled(true);
  if ( Scale <= 0.2 ) WebViewerTool->ScaleButtonMinus->setEnabled(false);
    else WebViewerTool->ScaleButtonMinus->setEnabled(true);

  WebViewerTool->PageEncodingButton->includeMenu(GroupCodecsMenu);
  WebViewerTool->PageEncodingButton->setText(EncodingAct->text());
  EncodingAct->setEnabled(false);


  connect ( this, SIGNAL(loadStarted()), WebViewerTool, SLOT(startLoading()));
  connect ( this, SIGNAL(loadProgress(int)), WebViewerTool, SLOT(setProgress(int)));
  connect ( this, SIGNAL(loadFinished(bool)), SLOT(loadingComplete(bool)));
  connect ( this, SIGNAL(linkClicked(QUrl)), SLOT(goAdress(QUrl)));
  connect ( WebViewerTool->PrevButton, SIGNAL(clicked()), SLOT(back()));
  connect ( WebViewerTool->ForwardButton, SIGNAL(clicked()), SLOT(forward()));
  connect ( WebViewerTool->RefreshButton, SIGNAL(clicked()), SLOT(reload()));
  connect ( WebViewerTool->ScaleButtonPlus, SIGNAL(clicked()), SLOT(scalePlus()));
  connect ( WebViewerTool->ScaleButtonMinus, SIGNAL(clicked()), SLOT(scaleMinus()));
  connect ( WebViewerTool->ClearHistoryButton, SIGNAL(clicked()), SLOT(clearHistory()));
  connect ( this->page(), SIGNAL(linkHovered(QString, QString, QString)), SLOT(setStatusBarText(QString, QString, QString)));
}

void CWebViewer :: addHistoryItem() {
  WebHistory->addItem(this);
  WebViewerTool->WebHistoryMenu->clear();
  int i = WebHistory->count();
  QAction * action;
  for ( int n = i -1; n >= 0; --n ) {
    action = WebViewerTool->WebHistoryMenu->addAction(WebHistory->icon(n),
                                                                                                        WebHistory->title(n),
                                                                                                        this,
                                                                                                        SLOT(goAdress()));
    action->setToolTip(WebHistory->link(n));
  }
  WebViewerTool->PrevButton->setEnabled(WebHistory->canGoBack());
  WebViewerTool->ForwardButton->setEnabled(WebHistory->canGoForward());
}


void CWebViewer :: back() {
  WebHistory->back();
  WebViewerTool->PrevButton->setEnabled(WebHistory->canGoBack());
  WebViewerTool->ForwardButton->setEnabled(WebHistory->canGoForward());
  lastAdress = QUrl(WebHistory->link());
  load(lastAdress);
}

void CWebViewer :: forward() {
  WebHistory->forward();
  WebViewerTool->PrevButton->setEnabled(WebHistory->canGoBack());
  WebViewerTool->ForwardButton->setEnabled(WebHistory->canGoForward());
  lastAdress = QUrl(WebHistory->link());
  load(lastAdress);
}

void CWebViewer :: scalePlus() {
  Scale = Scale + 0.2;
  WebViewerTool->ScalePage->setText(QString::number(Scale * 100) + "%");
  setZoomFactor(Scale);
  WebViewerTool->ScaleButtonMinus->setEnabled(true);
  if ( Scale >= 2. ) WebViewerTool->ScaleButtonPlus->setEnabled(false);
}

void CWebViewer :: scaleMinus() {
  Scale = Scale - 0.2;
  WebViewerTool->ScalePage->setText(QString::number(Scale * 100) + "%");
  setZoomFactor(Scale);
  WebViewerTool->ScaleButtonPlus->setEnabled(true);
  if ( Scale <= 0.4 ) WebViewerTool->ScaleButtonMinus->setEnabled(false);
}

void CWebViewer :: clearHistory() {
  WebHistory->clear();
  addHistoryItem();
  WebViewerTool->PrevButton->setEnabled(false);
  WebViewerTool->ForwardButton->setEnabled(false);
}

void CWebViewer :: setStatusBarText (QString link, QString, QString cont) {
  WebViewerStatus->setText(cont + "  -- " + link);
}

void CWebViewer :: setCastomPalette(QPalette palette, QColor color) {
  epal = palette;
  changeBackgroundPalette(&epal, darkerColor(color, 20));
  this->setPalette(palette);
  GroupCodecsMenu->setPalette(epal);
  foreach ( QMenu *menu, ListMenu ) menu->setPalette(epal);
  WebViewerTool->setBackColor(darkerColor(color, 30));
  WebViewerStatus->setPalette(palette);
  QColor fcolor = palette.color(QPalette::Text);
  WebViewerTool->setFontColor(fcolor);
}

void CWebViewer :: changeEncoding() {
  QAction *act = qobject_cast<QAction*>(sender());
  WebViewerTool->PageEncodingButton->setText(act->text());
  EncodingAct->setEnabled(true);
  act->setEnabled(false);
  QWebSettings::globalSettings()->setDefaultTextEncoding(act->toolTip());
  EncodingAct = act;
  this->reload();
}
