#include "../../Include/WebViewerTool.h"

CWebViewerTool :: CWebViewerTool ( PixmapsCache *pxcache, QWidget *wgt) : CToolBar(wgt) {
  pxCache = pxcache;
  History = addAction(tr("History"), tr("History"));
  ClearHistoryButton = addAction(*(pxCache->getIcon(126)), tr("Clear history"));
  QFont font;
  font = *(this->font());
  int width = (iconSize().width() + 8) * 2;
  addSeparator();
  PrevButton = addAction(*(pxCache->getIcon(120)), tr("Previous"));
  PrevButton->setMaximumWidth(width);
  PrevButton->setMinimumWidth(width);
  ForwardButton = addAction(*(pxCache->getIcon(121)), tr("Forward"));
  ForwardButton->setMaximumWidth(width);
  ForwardButton->setMinimumWidth(width);
  RefreshButton = addAction(*(pxCache->getIcon(122)), tr("Refresh"));
  RefreshButton->setMaximumWidth(width);
  RefreshButton->setMinimumWidth(width);

  Layout.addStretch(1);
  LoadProgressState = new QLabel();
  LoadProgress = new QProgressBar();
  LoadProgress->setRange(0, 100);
  LoadProgressState->setFont(font);
  LoadProgress->setFont(font);
  font.setBold(true);
  History->setFont(font);

  Layout.addWidget(LoadProgressState);
  Layout.addWidget(LoadProgress);

  PageEncodingButton = new CButton();
  Layout.addWidget(PageEncodingButton);

  addSeparator();
  ScaleButtonPlus = addAction(*(pxCache->getIcon(124)), tr("Scale up"));
  ScalePage = new QLabel();
  ScalePage->setMaximumHeight(iconSize().height() + 14);
  ScalePage->setMinimumHeight(iconSize().height() +14);
  ScalePage->setMaximumWidth(iconSize().width() * 3);
  ScalePage->setMinimumWidth(iconSize().width() * 3);
  ScalePage->setAlignment(Qt::AlignCenter);
  Layout.addWidget(ScalePage);
  ScaleButtonMinus = addAction(*(pxCache->getIcon(125)), tr("Scale down"));
  WebHistoryMenu = new QMenu(this);
  History->includeMenu(WebHistoryMenu);
}

void CWebViewerTool :: setFontSize() {
  CToolBar::setFontSize();
  QFont font;
  font = *(this->font());
  LoadProgressState->setFont(font);
  LoadProgress->setFont(font);
  font.setBold(true);
  History->setFont(font);
  int width = (iconSize().width() + 8) * 2;
  PrevButton->setMaximumWidth(width);
  PrevButton->setMinimumWidth(width);
  ForwardButton->setMaximumWidth(width);
  ForwardButton->setMinimumWidth(width);
  RefreshButton->setMaximumWidth(width);
  RefreshButton->setMinimumWidth(width);
  PageEncodingButton->setFont(font);
  ScalePage->setFont(font);
}

void CWebViewerTool :: setIconSize(QSize size) {
  CToolBar::setIconSize(size);
  int width = (iconSize().width() + 8) * 2;
  PrevButton->setMaximumWidth(width);
  PrevButton->setMinimumWidth(width);
  ForwardButton->setMaximumWidth(width);
  ForwardButton->setMinimumWidth(width);
  RefreshButton->setMaximumWidth(width);
  RefreshButton->setMinimumWidth(width);
}

void CWebViewerTool :: refreshTheme()  {
  PrevButton->setIcon(*(pxCache->getIcon(120)));
  ForwardButton->setIcon(*(pxCache->getIcon(121)));
  RefreshButton->setIcon(*(pxCache->getIcon(122)));
  ScaleButtonPlus->setIcon(*(pxCache->getIcon(124)));
  ScaleButtonMinus->setIcon(*(pxCache->getIcon(125)));
  ClearHistoryButton->setIcon(*(pxCache->getIcon(126)));
}

void CWebViewerTool :: startLoading() {
  LoadProgressState->setText(tr("Loading:"));
  LoadProgress->reset();
}

void CWebViewerTool :: setProgress(int progress) {
  LoadProgress->setValue(progress);
}
